C#****MDASUM                                                            09052000
      DOUBLE PRECISION FUNCTION MDASUM(N,DX,INCX)                       09053000
C                                                                       09054000
C     TAKES THE SUM OF THE ABSOLUTE VALUES.                             09055000
C     JACK DONGARRA, LINPACK, 3/11/78.                                  09056000
C                                                                       09057000
      DOUBLE PRECISION DX(1),DTEMP                                      09058000
      INTEGER I,INCX,M,MP1,N,NINCX                                      09059000
C                                                                       09060000
      MDASUM = 0.0D0                                                    09061000
      DTEMP = 0.0D0                                                     09062000
      IF(N.LE.0)RETURN                                                  09063000
      IF(INCX.EQ.1)GO TO 20                                             09064000
C                                                                       09065000
C        CODE FOR INCREMENT NOT EQUAL TO 1                              09066000
C                                                                       09067000
      NINCX = N*INCX                                                    09068000
      DO 10 I = 1,NINCX,INCX                                            09069000
        DTEMP = DTEMP + DABS(DX(I))                                     09070000
   10 CONTINUE                                                          09071000
      MDASUM = DTEMP                                                    09072000
      RETURN                                                            09073000
C                                                                       09074000
C        CODE FOR INCREMENT EQUAL TO 1                                  09075000
C                                                                       09076000
C                                                                       09077000
C        CLEAN-UP LOOP                                                  09078000
C                                                                       09079000
   20 M = MOD(N,6)                                                      09080000
      IF( M .EQ. 0 ) GO TO 40                                           09081000
      DO 30 I = 1,M                                                     09082000
        DTEMP = DTEMP + DABS(DX(I))                                     09083000
   30 CONTINUE                                                          09084000
      IF( N .LT. 6 ) GO TO 60                                           09085000
   40 MP1 = M + 1                                                       09086000
      DO 50 I = MP1,N,6                                                 09087000
        DTEMP = DTEMP + DABS(DX(I)) + DABS(DX(I + 1)) + DABS(DX(I + 2)) 09088000
     *  + DABS(DX(I + 3)) + DABS(DX(I + 4)) + DABS(DX(I + 5))           09089000
   50 CONTINUE                                                          09090000
   60 MDASUM = DTEMP                                                    09091000
      RETURN                                                            09092000
      END                                                               09093000
C#****MDAXPY                                                            09094000
      SUBROUTINE MDAXPY(N,DA,DX,INCX,DY,INCY)                           09095000
C                                                                       09096000
C     CONSTANT TIMES A VECTOR PLUS A VECTOR.                            09097000
C     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.                  09098000
C     JACK DONGARRA, LINPACK, 3/11/78.                                  09099000
C                                                                       09100000
      DOUBLE PRECISION DX(1),DY(1),DA                                   09101000
      INTEGER I,INCX,INCY,IX,IY,M,MP1,N                                 09102000
C                                                                       09103000
      IF(N.LE.0)RETURN                                                  09104000
      IF (DA .EQ. 0.0D0) RETURN                                         09105000
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20                               09106000
C                                                                       09107000
C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS                09108000
C          NOT EQUAL TO 1                                               09109000
C                                                                       09110000
      IX = 1                                                            09111000
      IY = 1                                                            09112000
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1                                 09113000
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1                                 09114000
      DO 10 I = 1,N                                                     09115000
        DY(IY) = DY(IY) + DA*DX(IX)                                     09116000
        IX = IX + INCX                                                  09117000
        IY = IY + INCY                                                  09118000
   10 CONTINUE                                                          09119000
      RETURN                                                            09120000
C                                                                       09121000
C        CODE FOR BOTH INCREMENTS EQUAL TO 1                            09122000
C                                                                       09123000
C                                                                       09124000
C        CLEAN-UP LOOP                                                  09125000
C                                                                       09126000
   20 M = MOD(N,4)                                                      09127000
      IF( M .EQ. 0 ) GO TO 40                                           09128000
      DO 30 I = 1,M                                                     09129000
        DY(I) = DY(I) + DA*DX(I)                                        09130000
   30 CONTINUE                                                          09131000
      IF( N .LT. 4 ) RETURN                                             09132000
   40 MP1 = M + 1                                                       09133000
      DO 50 I = MP1,N,4                                                 09134000
        DY(I) = DY(I) + DA*DX(I)                                        09135000
        DY(I + 1) = DY(I + 1) + DA*DX(I + 1)                            09136000
        DY(I + 2) = DY(I + 2) + DA*DX(I + 2)                            09137000
        DY(I + 3) = DY(I + 3) + DA*DX(I + 3)                            09138000
   50 CONTINUE                                                          09139000
      RETURN                                                            09140000
      END                                                               09141000
C#****MDCOPY                                                            09142000
      SUBROUTINE  MDCOPY(N,DX,INCX,DY,INCY)                             09143000
C                                                                       09144000
C     COPIES A VECTOR, X, TO A VECTOR, Y.                               09145000
C     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.                  09146000
C     JACK DONGARRA, LINPACK, 3/11/78.                                  09147000
C                                                                       09148000
      DOUBLE PRECISION DX(1),DY(1)                                      09149000
      INTEGER I,INCX,INCY,IX,IY,M,MP1,N                                 09150000
C                                                                       09151000
      IF(N.LE.0)RETURN                                                  09152000
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20                               09153000
C                                                                       09154000
C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS                09155000
C          NOT EQUAL TO 1                                               09156000
C                                                                       09157000
      IX = 1                                                            09158000
      IY = 1                                                            09159000
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1                                 09160000
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1                                 09161000
      DO 10 I = 1,N                                                     09162000
        DY(IY) = DX(IX)                                                 09163000
        IX = IX + INCX                                                  09164000
        IY = IY + INCY                                                  09165000
   10 CONTINUE                                                          09166000
      RETURN                                                            09167000
C                                                                       09168000
C        CODE FOR BOTH INCREMENTS EQUAL TO 1                            09169000
C                                                                       09170000
C                                                                       09171000
C        CLEAN-UP LOOP                                                  09172000
C                                                                       09173000
   20 M = MOD(N,7)                                                      09174000
      IF( M .EQ. 0 ) GO TO 40                                           09175000
      DO 30 I = 1,M                                                     09176000
        DY(I) = DX(I)                                                   09177000
   30 CONTINUE                                                          09178000
      IF( N .LT. 7 ) RETURN                                             09179000
   40 MP1 = M + 1                                                       09180000
      DO 50 I = MP1,N,7                                                 09181000
        DY(I) = DX(I)                                                   09182000
        DY(I + 1) = DX(I + 1)                                           09183000
        DY(I + 2) = DX(I + 2)                                           09184000
        DY(I + 3) = DX(I + 3)                                           09185000
        DY(I + 4) = DX(I + 4)                                           09186000
        DY(I + 5) = DX(I + 5)                                           09187000
        DY(I + 6) = DX(I + 6)                                           09188000
   50 CONTINUE                                                          09189000
      RETURN                                                            09190000
      END                                                               09191000
C#****MDDOT                                                             09192000
      DOUBLE PRECISION FUNCTION MDDOT(N,DX,INCX,DY,INCY)                09193000
C                                                                       09194000
C     FORMS THE DOT PRODUCT OF TWO VECTORS.                             09195000
C     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.                  09196000
C     JACK DONGARRA, LINPACK, 3/11/78.                                  09197000
C                                                                       09198000
      DOUBLE PRECISION DX(1),DY(1),DTEMP                                09199000
      INTEGER I,INCX,INCY,IX,IY,M,MP1,N                                 09200000
C                                                                       09201000
      MDDOT = 0.0D0                                                     09202000
      DTEMP = 0.0D0                                                     09203000
      IF(N.LE.0)RETURN                                                  09204000
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20                               09205000
C                                                                       09206000
C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS                09207000
C          NOT EQUAL TO 1                                               09208000
C                                                                       09209000
      IX = 1                                                            09210000
      IY = 1                                                            09211000
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1                                 09212000
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1                                 09213000
      DO 10 I = 1,N                                                     09214000
        DTEMP = DTEMP + DX(IX)*DY(IY)                                   09215000
        IX = IX + INCX                                                  09216000
        IY = IY + INCY                                                  09217000
   10 CONTINUE                                                          09218000
      MDDOT = DTEMP                                                     09219000
      RETURN                                                            09220000
C                                                                       09221000
C        CODE FOR BOTH INCREMENTS EQUAL TO 1                            09222000
C                                                                       09223000
C                                                                       09224000
C        CLEAN-UP LOOP                                                  09225000
C                                                                       09226000
   20 M = MOD(N,5)                                                      09227000
      IF( M .EQ. 0 ) GO TO 40                                           09228000
      DO 30 I = 1,M                                                     09229000
        DTEMP = DTEMP + DX(I)*DY(I)                                     09230000
   30 CONTINUE                                                          09231000
      IF( N .LT. 5 ) GO TO 60                                           09232000
   40 MP1 = M + 1                                                       09233000
      DO 50 I = MP1,N,5                                                 09234000
        DTEMP = DTEMP + DX(I)*DY(I) + DX(I + 1)*DY(I + 1) +             09235000
     *   DX(I + 2)*DY(I + 2) + DX(I + 3)*DY(I + 3) + DX(I + 4)*DY(I + 4)09236000
   50 CONTINUE                                                          09237000
   60 MDDOT = DTEMP                                                     09238000
      RETURN                                                            09239000
      END                                                               09240000
C#****MDGEA1                                                            09241000
      SUBROUTINE MDGEA1(JOB,A,B,Z,IPVT,DETV,LDA,N,INFO,RCOND,SNAMEI,    09242000
     *  MXNAME)                                                         09243000
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::09244000
C* COPYRIGHT--  1981 BY SCA, INC.  ALL RIGHTS RESERVED.                 09245000
C                                                                       09246000
C  NAME     --  MDGEA1                                                  09247000
C                                                                       09248000
C  PURPOSE  --  MDGEA1 INVERTS OR COMPUTES THE DETERMINANT OF A         09249000
C               GENERAL MATRIX OR SOLVE A LINEAR SYSTEM (AX=B OR A'X=B) 09250000
C               USING GAUSSIAN ELIMINATION                              09251000
C                                                                       09252000
C  USAGE    --  CALL   MDGEA1( ... )                                    09253000
C                                                                       09254000
C  ARGUMENTS--                                                          09255000
C                                                                       09256000
C    JOB        INTEGER SCALAR, INPUT ONLY                              09257000
C               JOB = 000 FACTOR A MATRIX AND COMPUTE RCOND ONLY        09258000
C                   = 001 INVERSE ONLY                                  09259000
C                   = 010 DET ONLY                                      09260000
C                   = 011 INVERSE AND DET                               09261000
C                   = 100 SOLVE ONLY               (SOLVE AX=B)         09262000
C                   = 101 SOLVE AND INVERSE        (SOLVE AX=B)         09263000
C                   = 110 SOLVE AND DET            (SOLVE AX=B)         09264000
C                   = 111 SOLVE, INVERSE, AND DET  (SOLVE AX=B)         09265000
C                   = 200 SOLVE ONLY               (SOLVE A'X=B)        09266000
C                   = 201 SOLVE AND INVERSE        (SOLVE A'X=B)        09267000
C                   = 210 SOLVE AND DET            (SOLVE A'X=B)        09268000
C                   = 211 SOLVE, INVERSE, AND DET  (SOLVE A'X=B)        09269000
C                                                                       09270000
C    A          DOUBLE PRECISION ARRAY(2), INPUT/OUTPUT                 09271000
C               INPUT : THE MATRIX TO BE INVERTED                       09272000
C               OUTPUT: THE INVERTED MATRIX                             09273000
C                                                                       09274000
C    B          DOUBLE PRECISION ARRAY(1), INPUT/OUTPUT                 09275000
C               INPUT : THE B MATRIX IN THE LINEAR SYSTEM AX=B          09276000
C               OUTPUT: THE X MATRIX                                    09277000
C                                                                       09278000
C    Z          DOUBLE PRECISION ARRAY(1), OUTPUT ONLY                  09279000
C               A WORK VECTOR                                           09280000
C                                                                       09281000
C    IPVT       INTEGER ARRAY(1), OUTPUT ONLY                           09282000
C               A SCRATCH VECTOR FOR STORING THE PIVOT INDICATORS       09283000
C                                                                       09284000
C    DETV       DOUBLE PRECISION SCALAR, OUTPUT ONLY                    09285000
C               THE DETERMINANT OF THE MATRIX A                         09286000
C                                                                       09287000
C    LDA        INTEGER SCALAR, INPUT ONLY                              09288000
C               THE LEADING DIMENSION OF THE MATRIX A                   09289000
C                                                                       09290000
C    N          INTEGER SCALAR, INPUT ONLY                              09291000
C               THE ACTUAL ORDER OF THE MATRIX A                        09292000
C                                                                       09293000
C    INFO       INTEGER SCALAR, OUTPUT                                  09294000
C               INFO = 0 NO ERROR                                       09295000
C                    =-1 A IS SINGULAR                                  09296000
C                                                                       09297000
C    RCOND      DOUBLE PRECISION SCALAR, OUTPUT ONLY                    09298000
C               AN ESTIMATE OF THE RECIPROCAL CONDITION OF A            09299000
C                                                                       09300000
C    SNAMEI     CHARACTER*8 SCALAR, INPUT ONLY                          09301000
C               THE CALLING SUBROUTINE NAME                             09302000
C                                                                       09303000
C    MXNAME     CHARACTER*8 SCALAR, INPUT ONLY                          09304000
C               THE IDENTIFICATION FOR MATRIX A                         09305000
C                                                                       09306000
C  REMARKS  --  NONE                                                    09307000
C                                                                       09308000
C  SUBPROGRAMS  REQUIRED --                                             09309000
C               ABGPRT, ABGDIM, MDPOCO, MDPOSL, MDPODI, ABGRTN          09310000
C                                                                       09311000
C  FORTRAN FUNCTIONS REQUIRED --                                        09312000
C               MOD                                                     09313000
C                                                                       09314000
C  COMMON BLOCKS USED --                                                09315000
C               CMIOPA                                                  09316000
C                                                                       09317000
C     CMIOPA    -IPRT                                                   09318000
C                                                                       09319000
C  REFERENCES-- NONE                                                    09320000
C                                                                       09321000
C  PROGRAMMER-- LON-MU LIU                                              09322000
C                                                                       09323000
C  LAST REVISED-- DECEMBER, 1981                                        09324000
C                                                                       09325000
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::09326000
C                                                                       09327000
      INTEGER          IGORTN, INFO  , IPVT  , JOBT  , JOB   ,          09328000
     *                 LDA   , LEVOT , N                                09329000
C                                                                       09330000
      DOUBLE PRECISION A     , B     , DETV  , DET   , RCOND , Z        09331000
C-CHR                                                                   09332000
      DOUBLE PRECISION MXNAME, SNAMEI, SNAME                            09333000
C/                                                                      09334000
C+CHR                                                                   09335000
C&    CHARACTER*8      MXNAME, SNAMEI, SNAME                            09336000
C/                                                                      09337000
C                                                                       09338000
      COMMON / BASIC / ICMDIN, IIPT, IPRT
      DIMENSION A(LDA,N),B(N),Z(N),DET(2),IPVT(N)                       09344000
      DATA  SNAME /6HMDGEA1/                                            09345000
C   1 CONTINUE                                                          09346000
C     DEBUG SUBCHK                                                      09347000
C     AT 1                                                              09348000
C     TRACE ON                                                          09349000
      LEVOT=0                                                           09350000
C     CALL ABGDIM(1,SNAME,LDA,N,1,1,1,1)                                09351000
C     IF(IGORTN.EQ.2) GO TO 9800                                        09352000
C                                                                       09353000
C     FACTOR A DOUBLE PRECISION MATRIX BY GAUSSIAN ELIMINATION AND      09354000
C     ESTIMATE THE CONDITION OF THE MATRIX, NOTE A=R'R                  09355000
C                                                                       09356000
      DETV=0.D0                                                         09357000
      INFO=0                                                            09358000
      CALL MDGECO(A,LDA,N,IPVT,RCOND,Z)                                 09359000
      IF((1.0D0+RCOND).GT.1.0D0) GO TO 400                              09360000
      INFO=-1                                                           09361000
      WRITE(IPRT,205) MXNAME,SNAMEI,RCOND                               09362000
  205 FORMAT(                                                           09363000
     * ' ** THE MATRIX ',A6,' TO BE INVERTED ( IN SUBROUTINE ',A8,') IS'09364000
     */'    SINGULAR TO WORKING PRECISION; JOB ABANDONED. THE RCOND IS '09365000
     *,G16.8/1X)                                                        09366000
      GO TO 9800                                                        09367000
  400 CONTINUE                                                          09368000
      IF(JOB.EQ.0) GO TO 9800                                           09369000
      IF(JOB.LE.99) GO TO 500                                           09370000
C                                                                       09371000
C     SOLVE THE DOUBLE PRECISION SYMMETRIC POSITIVE DEFINITE SYSTEM     09372000
C                                                                       09373000
      JOBT=JOB/100-1                                                    09374000
      CALL MDGESL(A,LDA,N,IPVT,B,JOBT)                                  09375000
  500 CONTINUE                                                          09376000
      JOBT=MOD(JOB,100)                                                 09377000
      IF(JOBT.LE.0) GO TO 9800                                          09378000
C                                                                       09379000
C     COMPUTE THE DETERMINANT AND INVERSE OF R                          09380000
C                                                                       09381000
      CALL MDGEDI(A,LDA,N,IPVT,DET,Z,JOBT)                              09382000
      IF((JOBT/10).EQ.1) DETV=DET(1)*(10.D0**DET(2))                    09383000
 9800 CONTINUE                                                          09384000
C     IF(LEVOT.GT.0) CALL ABGRTN(SNAME)                                 09385000
      RETURN                                                            09386000
      END                                                               09387000
C#****MDGECO                                                            09388000
      SUBROUTINE MDGECO(A,LDA,N,IPVT,RCOND,Z)                           09389000
      INTEGER LDA,N,IPVT(1)                                             09390000
      DOUBLE PRECISION A(LDA,1),Z(1)                                    09391000
      DOUBLE PRECISION RCOND                                            09392000
C                                                                       09393000
C     MDGECO FACTORS A DOUBLE PRECISION MATRIX BY GAUSSIAN ELIMINATION  09394000
C     AND ESTIMATES THE CONDITION OF THE MATRIX.                        09395000
C                                                                       09396000
C     IF  RCOND  IS NOT NEEDED, MDGEFA IS SLIGHTLY FASTER.              09397000
C     TO SOLVE  A*X = B , FOLLOW MDGECO BY MDGESL.                      09398000
C     TO COMPUTE  INVERSE(A)*C , FOLLOW MDGECO BY MDGESL.               09399000
C     TO COMPUTE  DETERMINANT(A) , FOLLOW MDGECO BY MDGEDI.             09400000
C     TO COMPUTE  INVERSE(A) , FOLLOW MDGECO BY MDGEDI.                 09401000
C                                                                       09402000
C     ON ENTRY                                                          09403000
C                                                                       09404000
C        A       DOUBLE PRECISION(LDA, N)                               09405000
C                THE MATRIX TO BE FACTORED.                             09406000
C                                                                       09407000
C        LDA     INTEGER                                                09408000
C                THE LEADING DIMENSION OF THE ARRAY  A .                09409000
C                                                                       09410000
C        N       INTEGER                                                09411000
C                THE ORDER OF THE MATRIX  A .                           09412000
C                                                                       09413000
C     ON RETURN                                                         09414000
C                                                                       09415000
C        A       AN UPPER TRIANGULAR MATRIX AND THE MULTIPLIERS         09416000
C                WHICH WERE USED TO OBTAIN IT.                          09417000
C                THE FACTORIZATION CAN BE WRITTEN  A = L*U  WHERE       09418000
C                L  IS A PRODUCT OF PERMUTATION AND UNIT LOWER          09419000
C                TRIANGULAR MATRICES AND  U  IS UPPER TRIANGULAR.       09420000
C                                                                       09421000
C        IPVT    INTEGER(N)                                             09422000
C                AN INTEGER VECTOR OF PIVOT INDICES.                    09423000
C                                                                       09424000
C        RCOND   DOUBLE PRECISION                                       09425000
C                AN ESTIMATE OF THE RECIPROCAL CONDITION OF  A .        09426000
C                FOR THE SYSTEM  A*X = B , RELATIVE PERTURBATIONS       09427000
C                IN  A  AND  B  OF SIZE  EPSILON  MAY CAUSE             09428000
C                RELATIVE PERTURBATIONS IN  X  OF SIZE  EPSILON/RCOND . 09429000
C                IF  RCOND  IS SO SMALL THAT THE LOGICAL EXPRESSION     09430000
C                           1.0 + RCOND .EQ. 1.0                        09431000
C                IS TRUE, THEN  A  MAY BE SINGULAR TO WORKING           09432000
C                PRECISION.  IN PARTICULAR,  RCOND  IS ZERO  IF         09433000
C                EXACT SINGULARITY IS DETECTED OR THE ESTIMATE          09434000
C                UNDERFLOWS.                                            09435000
C                                                                       09436000
C        Z       DOUBLE PRECISION(N)                                    09437000
C                A WORK VECTOR WHOSE CONTENTS ARE USUALLY UNIMPORTANT.  09438000
C                IF  A  IS CLOSE TO A SINGULAR MATRIX, THEN  Z  IS      09439000
C                AN APPROXIMATE NULL VECTOR IN THE SENSE THAT           09440000
C                NORM(A*Z) = RCOND*NORM(A)*NORM(Z) .                    09441000
C                                                                       09442000
C     LINPACK. THIS VERSION DATED 08/14/78 .                            09443000
C     CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LAB.      09444000
C                                                                       09445000
C     SUBROUTINES AND FUNCTIONS                                         09446000
C                                                                       09447000
C     LINPACK MDGEFA                                                    09448000
C     BLAS MDAXPY,MDDOT,MDSCAL,MDASUM                                   09449000
C     FORTRAN DABS,DMAX1,DSIGN                                          09450000
C                                                                       09451000
C     INTERNAL VARIABLES                                                09452000
C                                                                       09453000
      DOUBLE PRECISION MDDOT,EK,T,WK,WKM                                09454000
      DOUBLE PRECISION ANORM,S,MDASUM,SM,YNORM                          09455000
      INTEGER INFO,J,K,KB,KP1,L                                         09456000
C                                                                       09457000
C                                                                       09458000
C     COMPUTE 1-NORM OF A                                               09459000
C                                                                       09460000
      ANORM = 0.0D0                                                     09461000
      DO 10 J = 1, N                                                    09462000
         ANORM = DMAX1(ANORM,MDASUM(N,A(1,J),1))                        09463000
   10 CONTINUE                                                          09464000
C                                                                       09465000
C     FACTOR                                                            09466000
C                                                                       09467000
      CALL MDGEFA(A,LDA,N,IPVT,INFO)                                    09468000
C                                                                       09469000
C     RCOND = 1/(NORM(A)*(ESTIMATE OF NORM(INVERSE(A)))) .              09470000
C     ESTIMATE = NORM(Z)/NORM(Y) WHERE  A*Z = Y  AND  TRANS(A)*Y = E .  09471000
C     TRANS(A)  IS THE TRANSPOSE OF A .  THE COMPONENTS OF  E  ARE      09472000
C     CHOSEN TO CAUSE MAXIMUM LOCAL GROWTH IN THE ELEMENTS OF W  WHERE  09473000
C     TRANS(U)*W = E .  THE VECTORS ARE FREQUENTLY RESCALED TO AVOID    09474000
C     OVERFLOW.                                                         09475000
C                                                                       09476000
C     SOLVE TRANS(U)*W = E                                              09477000
C                                                                       09478000
      EK = 1.0D0                                                        09479000
      DO 20 J = 1, N                                                    09480000
         Z(J) = 0.0D0                                                   09481000
   20 CONTINUE                                                          09482000
      DO 100 K = 1, N                                                   09483000
         IF (Z(K) .NE. 0.0D0) EK = DSIGN(EK,-Z(K))                      09484000
         IF (DABS(EK-Z(K)) .LE. DABS(A(K,K))) GO TO 30                  09485000
            S = DABS(A(K,K))/DABS(EK-Z(K))                              09486000
            CALL MDSCAL(N,S,Z,1)                                        09487000
            EK = S*EK                                                   09488000
   30    CONTINUE                                                       09489000
         WK = EK - Z(K)                                                 09490000
         WKM = -EK - Z(K)                                               09491000
         S = DABS(WK)                                                   09492000
         SM = DABS(WKM)                                                 09493000
         IF (A(K,K) .EQ. 0.0D0) GO TO 40                                09494000
            WK = WK/A(K,K)                                              09495000
            WKM = WKM/A(K,K)                                            09496000
         GO TO 50                                                       09497000
   40    CONTINUE                                                       09498000
            WK = 1.0D0                                                  09499000
            WKM = 1.0D0                                                 09500000
   50    CONTINUE                                                       09501000
         KP1 = K + 1                                                    09502000
         IF (KP1 .GT. N) GO TO 90                                       09503000
            DO 60 J = KP1, N                                            09504000
               SM = SM + DABS(Z(J)+WKM*A(K,J))                          09505000
               Z(J) = Z(J) + WK*A(K,J)                                  09506000
               S = S + DABS(Z(J))                                       09507000
   60       CONTINUE                                                    09508000
            IF (S .GE. SM) GO TO 80                                     09509000
               T = WKM - WK                                             09510000
               WK = WKM                                                 09511000
               DO 70 J = KP1, N                                         09512000
                  Z(J) = Z(J) + T*A(K,J)                                09513000
   70          CONTINUE                                                 09514000
   80       CONTINUE                                                    09515000
   90    CONTINUE                                                       09516000
         Z(K) = WK                                                      09517000
  100 CONTINUE                                                          09518000
      S = 1.0D0/MDASUM(N,Z,1)                                           09519000
      CALL MDSCAL(N,S,Z,1)                                              09520000
C                                                                       09521000
C     SOLVE TRANS(L)*Y = W                                              09522000
C                                                                       09523000
      DO 120 KB = 1, N                                                  09524000
         K = N + 1 - KB                                                 09525000
         IF (K .LT. N) Z(K) = Z(K) + MDDOT(N-K,A(K+1,K),1,Z(K+1),1)     09526000
         IF (DABS(Z(K)) .LE. 1.0D0) GO TO 110                           09527000
            S = 1.0D0/DABS(Z(K))                                        09528000
            CALL MDSCAL(N,S,Z,1)                                        09529000
  110    CONTINUE                                                       09530000
         L = IPVT(K)                                                    09531000
         T = Z(L)                                                       09532000
         Z(L) = Z(K)                                                    09533000
         Z(K) = T                                                       09534000
  120 CONTINUE                                                          09535000
      S = 1.0D0/MDASUM(N,Z,1)                                           09536000
      CALL MDSCAL(N,S,Z,1)                                              09537000
C                                                                       09538000
      YNORM = 1.0D0                                                     09539000
C                                                                       09540000
C     SOLVE L*V = Y                                                     09541000
C                                                                       09542000
      DO 140 K = 1, N                                                   09543000
         L = IPVT(K)                                                    09544000
         T = Z(L)                                                       09545000
         Z(L) = Z(K)                                                    09546000
         Z(K) = T                                                       09547000
         IF (K .LT. N) CALL MDAXPY(N-K,T,A(K+1,K),1,Z(K+1),1)           09548000
         IF (DABS(Z(K)) .LE. 1.0D0) GO TO 130                           09549000
            S = 1.0D0/DABS(Z(K))                                        09550000
            CALL MDSCAL(N,S,Z,1)                                        09551000
            YNORM = S*YNORM                                             09552000
  130    CONTINUE                                                       09553000
  140 CONTINUE                                                          09554000
      S = 1.0D0/MDASUM(N,Z,1)                                           09555000
      CALL MDSCAL(N,S,Z,1)                                              09556000
      YNORM = S*YNORM                                                   09557000
C                                                                       09558000
C     SOLVE  U*Z = V                                                    09559000
C                                                                       09560000
      DO 160 KB = 1, N                                                  09561000
         K = N + 1 - KB                                                 09562000
         IF (DABS(Z(K)) .LE. DABS(A(K,K))) GO TO 150                    09563000
            S = DABS(A(K,K))/DABS(Z(K))                                 09564000
            CALL MDSCAL(N,S,Z,1)                                        09565000
            YNORM = S*YNORM                                             09566000
  150    CONTINUE                                                       09567000
         IF (A(K,K) .NE. 0.0D0) Z(K) = Z(K)/A(K,K)                      09568000
         IF (A(K,K) .EQ. 0.0D0) Z(K) = 1.0D0                            09569000
         T = -Z(K)                                                      09570000
         CALL MDAXPY(K-1,T,A(1,K),1,Z(1),1)                             09571000
  160 CONTINUE                                                          09572000
C     MAKE ZNORM = 1.0                                                  09573000
      S = 1.0D0/MDASUM(N,Z,1)                                           09574000
      CALL MDSCAL(N,S,Z,1)                                              09575000
      YNORM = S*YNORM                                                   09576000
C                                                                       09577000
      IF (ANORM .NE. 0.0D0) RCOND = YNORM/ANORM                         09578000
      IF (ANORM .EQ. 0.0D0) RCOND = 0.0D0                               09579000
      RETURN                                                            09580000
      END                                                               09581000
C#****MDGEDI                                                            09582000
      SUBROUTINE MDGEDI(A,LDA,N,IPVT,DET,WORK,JOB)                      09583000
      INTEGER LDA,N,IPVT(1),JOB                                         09584000
      DOUBLE PRECISION A(LDA,1),DET(2),WORK(1)                          09585000
C                                                                       09586000
C     MDGEDI COMPUTES THE DETERMINANT AND INVERSE OF A MATRIX           09587000
C     USING THE FACTORS COMPUTED BY MDGECO OR MDGEFA.                   09588000
C                                                                       09589000
C     ON ENTRY                                                          09590000
C                                                                       09591000
C        A       DOUBLE PRECISION(LDA, N)                               09592000
C                THE OUTPUT FROM MDGECO OR MDGEFA.                      09593000
C                                                                       09594000
C        LDA     INTEGER                                                09595000
C                THE LEADING DIMENSION OF THE ARRAY  A .                09596000
C                                                                       09597000
C        N       INTEGER                                                09598000
C                THE ORDER OF THE MATRIX  A .                           09599000
C                                                                       09600000
C        IPVT    INTEGER(N)                                             09601000
C                THE PIVOT VECTOR FROM MDGECO OR MDGEFA.                09602000
C                                                                       09603000
C        WORK    DOUBLE PRECISION(N)                                    09604000
C                WORK VECTOR.  CONTENTS DESTROYED.                      09605000
C                                                                       09606000
C        JOB     INTEGER                                                09607000
C                = 11   BOTH DETERMINANT AND INVERSE.                   09608000
C                = 01   INVERSE ONLY.                                   09609000
C                = 10   DETERMINANT ONLY.                               09610000
C                                                                       09611000
C     ON RETURN                                                         09612000
C                                                                       09613000
C        A       INVERSE OF ORIGINAL MATRIX IF REQUESTED.               09614000
C                OTHERWISE UNCHANGED.                                   09615000
C                                                                       09616000
C        DET     DOUBLE PRECISION(2)                                    09617000
C                DETERMINANT OF ORIGINAL MATRIX IF REQUESTED.           09618000
C                OTHERWISE NOT REFERENCED.                              09619000
C                DETERMINANT = DET(1) * 10.0**DET(2)                    09620000
C                WITH  1.0 .LE. DABS(DET(1)) .LT. 10.0                  09621000
C                OR  DET(1) .EQ. 0.0 .                                  09622000
C                                                                       09623000
C     ERROR CONDITION                                                   09624000
C                                                                       09625000
C        A DIVISION BY ZERO WILL OCCUR IF THE INPUT FACTOR CONTAINS     09626000
C        A ZERO ON THE DIAGONAL AND THE INVERSE IS REQUESTED.           09627000
C        IT WILL NOT OCCUR IF THE SUBROUTINES ARE CALLED CORRECTLY      09628000
C        AND IF MDGECO HAS SET RCOND .GT. 0.0 OR MDGEFA HAS SET         09629000
C        INFO .EQ. 0 .                                                  09630000
C                                                                       09631000
C     LINPACK. THIS VERSION DATED 08/14/78 .                            09632000
C     CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LAB.      09633000
C                                                                       09634000
C     SUBROUTINES AND FUNCTIONS                                         09635000
C                                                                       09636000
C     BLAS MDAXPY,MDSCAL,MDSWAP                                         09637000
C     FORTRAN DABS,MOD                                                  09638000
C                                                                       09639000
C     INTERNAL VARIABLES                                                09640000
C                                                                       09641000
      DOUBLE PRECISION T                                                09642000
      DOUBLE PRECISION TEN                                              09643000
      INTEGER I,J,K,KB,KP1,L,NM1                                        09644000
C                                                                       09645000
C                                                                       09646000
C     COMPUTE DETERMINANT                                               09647000
C                                                                       09648000
      IF (JOB/10 .EQ. 0) GO TO 70                                       09649000
         DET(1) = 1.0D0                                                 09650000
         DET(2) = 0.0D0                                                 09651000
         TEN = 10.0D0                                                   09652000
         DO 50 I = 1, N                                                 09653000
            IF (IPVT(I) .NE. I) DET(1) = -DET(1)                        09654000
            DET(1) = A(I,I)*DET(1)                                      09655000
C        ...EXIT                                                        09656000
            IF (DET(1) .EQ. 0.0D0) GO TO 60                             09657000
   10       IF (DABS(DET(1)) .GE. 1.0D0) GO TO 20                       09658000
               DET(1) = TEN*DET(1)                                      09659000
               DET(2) = DET(2) - 1.0D0                                  09660000
            GO TO 10                                                    09661000
   20       CONTINUE                                                    09662000
   30       IF (DABS(DET(1)) .LT. TEN) GO TO 40                         09663000
               DET(1) = DET(1)/TEN                                      09664000
               DET(2) = DET(2) + 1.0D0                                  09665000
            GO TO 30                                                    09666000
   40       CONTINUE                                                    09667000
   50    CONTINUE                                                       09668000
   60    CONTINUE                                                       09669000
   70 CONTINUE                                                          09670000
C                                                                       09671000
C     COMPUTE INVERSE(U)                                                09672000
C                                                                       09673000
      IF (MOD(JOB,10) .EQ. 0) GO TO 150                                 09674000
         DO 100 K = 1, N                                                09675000
            A(K,K) = 1.0D0/A(K,K)                                       09676000
            T = -A(K,K)                                                 09677000
            CALL MDSCAL(K-1,T,A(1,K),1)                                 09678000
            KP1 = K + 1                                                 09679000
            IF (N .LT. KP1) GO TO 90                                    09680000
            DO 80 J = KP1, N                                            09681000
               T = A(K,J)                                               09682000
               A(K,J) = 0.0D0                                           09683000
               CALL MDAXPY(K,T,A(1,K),1,A(1,J),1)                       09684000
   80       CONTINUE                                                    09685000
   90       CONTINUE                                                    09686000
  100    CONTINUE                                                       09687000
C                                                                       09688000
C        FORM INVERSE(U)*INVERSE(L)                                     09689000
C                                                                       09690000
         NM1 = N - 1                                                    09691000
         IF (NM1 .LT. 1) GO TO 140                                      09692000
         DO 130 KB = 1, NM1                                             09693000
            K = N - KB                                                  09694000
            KP1 = K + 1                                                 09695000
            DO 110 I = KP1, N                                           09696000
               WORK(I) = A(I,K)                                         09697000
               A(I,K) = 0.0D0                                           09698000
  110       CONTINUE                                                    09699000
            DO 120 J = KP1, N                                           09700000
               T = WORK(J)                                              09701000
               CALL MDAXPY(N,T,A(1,J),1,A(1,K),1)                       09702000
  120       CONTINUE                                                    09703000
            L = IPVT(K)                                                 09704000
            IF (L .NE. K) CALL MDSWAP(N,A(1,K),1,A(1,L),1)              09705000
  130    CONTINUE                                                       09706000
  140    CONTINUE                                                       09707000
  150 CONTINUE                                                          09708000
      RETURN                                                            09709000
      END                                                               09710000
C#****MDGEFA                                                            09711000
      SUBROUTINE MDGEFA(A,LDA,N,IPVT,INFO)                              09712000
      INTEGER LDA,N,IPVT(1),INFO                                        09713000
      DOUBLE PRECISION A(LDA,1)                                         09714000
C                                                                       09715000
C     MDGEFA FACTORS A DOUBLE PRECISION MATRIX BY GAUSSIAN ELIMINATION. 09716000
C                                                                       09717000
C     MDGEFA IS USUALLY CALLED BY MDGECO, BUT IT CAN BE CALLED          09718000
C     DIRECTLY WITH A SAVING IN TIME IF  RCOND  IS NOT NEEDED.          09719000
C     (TIME FOR MDGECO) = (1 + 9/N)*(TIME FOR MDGEFA) .                 09720000
C                                                                       09721000
C     ON ENTRY                                                          09722000
C                                                                       09723000
C        A       DOUBLE PRECISION(LDA, N)                               09724000
C                THE MATRIX TO BE FACTORED.                             09725000
C                                                                       09726000
C        LDA     INTEGER                                                09727000
C                THE LEADING DIMENSION OF THE ARRAY  A .                09728000
C                                                                       09729000
C        N       INTEGER                                                09730000
C                THE ORDER OF THE MATRIX  A .                           09731000
C                                                                       09732000
C     ON RETURN                                                         09733000
C                                                                       09734000
C        A       AN UPPER TRIANGULAR MATRIX AND THE MULTIPLIERS         09735000
C                WHICH WERE USED TO OBTAIN IT.                          09736000
C                THE FACTORIZATION CAN BE WRITTEN  A = L*U  WHERE       09737000
C                L  IS A PRODUCT OF PERMUTATION AND UNIT LOWER          09738000
C                TRIANGULAR MATRICES AND  U  IS UPPER TRIANGULAR.       09739000
C                                                                       09740000
C        IPVT    INTEGER(N)                                             09741000
C                AN INTEGER VECTOR OF PIVOT INDICES.                    09742000
C                                                                       09743000
C        INFO    INTEGER                                                09744000
C                = 0  NORMAL VALUE.                                     09745000
C                = K  IF  U(K,K) .EQ. 0.0 .  THIS IS NOT AN ERROR       09746000
C                     CONDITION FOR THIS SUBROUTINE, BUT IT DOES        09747000
C                     INDICATE THAT MDGESL OR MDGEDI WILL DIVIDE BY ZERO09748000
C                     IF CALLED.  USE  RCOND  IN MDGECO FOR A RELIABLE  09749000
C                     INDICATION OF SINGULARITY.                        09750000
C                                                                       09751000
C     LINPACK. THIS VERSION DATED 08/14/78 .                            09752000
C     CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LAB.      09753000
C                                                                       09754000
C     SUBROUTINES AND FUNCTIONS                                         09755000
C                                                                       09756000
C     BLAS MDAXPY,MDSCAL,IDAMAX                                         09757000
C                                                                       09758000
C     INTERNAL VARIABLES                                                09759000
C                                                                       09760000
      DOUBLE PRECISION T                                                09761000
      INTEGER IDAMAX,J,K,KP1,L,NM1                                      09762000
C                                                                       09763000
C                                                                       09764000
C     GAUSSIAN ELIMINATION WITH PARTIAL PIVOTING                        09765000
C                                                                       09766000
      INFO = 0                                                          09767000
      NM1 = N - 1                                                       09768000
      IF (NM1 .LT. 1) GO TO 70                                          09769000
      DO 60 K = 1, NM1                                                  09770000
         KP1 = K + 1                                                    09771000
C                                                                       09772000
C        FIND L = PIVOT INDEX                                           09773000
C                                                                       09774000
         L = IDAMAX(N-K+1,A(K,K),1) + K - 1                             09775000
         IPVT(K) = L                                                    09776000
C                                                                       09777000
C        ZERO PIVOT IMPLIES THIS COLUMN ALREADY TRIANGULARIZED          09778000
C                                                                       09779000
         IF (A(L,K) .EQ. 0.0D0) GO TO 40                                09780000
C                                                                       09781000
C           INTERCHANGE IF NECESSARY                                    09782000
C                                                                       09783000
            IF (L .EQ. K) GO TO 10                                      09784000
               T = A(L,K)                                               09785000
               A(L,K) = A(K,K)                                          09786000
               A(K,K) = T                                               09787000
   10       CONTINUE                                                    09788000
C                                                                       09789000
C           COMPUTE MULTIPLIERS                                         09790000
C                                                                       09791000
            T = -1.0D0/A(K,K)                                           09792000
            CALL MDSCAL(N-K,T,A(K+1,K),1)                               09793000
C                                                                       09794000
C           ROW ELIMINATION WITH COLUMN INDEXING                        09795000
C                                                                       09796000
            DO 30 J = KP1, N                                            09797000
               T = A(L,J)                                               09798000
               IF (L .EQ. K) GO TO 20                                   09799000
                  A(L,J) = A(K,J)                                       09800000
                  A(K,J) = T                                            09801000
   20          CONTINUE                                                 09802000
               CALL MDAXPY(N-K,T,A(K+1,K),1,A(K+1,J),1)                 09803000
   30       CONTINUE                                                    09804000
         GO TO 50                                                       09805000
   40    CONTINUE                                                       09806000
            INFO = K                                                    09807000
   50    CONTINUE                                                       09808000
   60 CONTINUE                                                          09809000
   70 CONTINUE                                                          09810000
      IPVT(N) = N                                                       09811000
      IF (A(N,N) .EQ. 0.0D0) INFO = N                                   09812000
      RETURN                                                            09813000
      END                                                               09814000
C#****MDGESL                                                            09815000
      SUBROUTINE MDGESL(A,LDA,N,IPVT,B,JOB)                             09816000
      INTEGER LDA,N,IPVT(1),JOB                                         09817000
      DOUBLE PRECISION A(LDA,1),B(1)                                    09818000
C                                                                       09819000
C     MDGESL SOLVES THE DOUBLE PRECISION SYSTEM                         09820000
C     A * X = B  OR  TRANS(A) * X = B                                   09821000
C     USING THE FACTORS COMPUTED BY MDGECO OR MDGEFA.                   09822000
C                                                                       09823000
C     ON ENTRY                                                          09824000
C                                                                       09825000
C        A       DOUBLE PRECISION(LDA, N)                               09826000
C                THE OUTPUT FROM MDGECO OR MDGEFA.                      09827000
C                                                                       09828000
C        LDA     INTEGER                                                09829000
C                THE LEADING DIMENSION OF THE ARRAY  A .                09830000
C                                                                       09831000
C        N       INTEGER                                                09832000
C                THE ORDER OF THE MATRIX  A .                           09833000
C                                                                       09834000
C        IPVT    INTEGER(N)                                             09835000
C                THE PIVOT VECTOR FROM MDGECO OR MDGEFA.                09836000
C                                                                       09837000
C        B       DOUBLE PRECISION(N)                                    09838000
C                THE RIGHT HAND SIDE VECTOR.                            09839000
C                                                                       09840000
C        JOB     INTEGER                                                09841000
C                = 0         TO SOLVE  A*X = B ,                        09842000
C                = NONZERO   TO SOLVE  TRANS(A)*X = B  WHERE            09843000
C                            TRANS(A)  IS THE TRANSPOSE.                09844000
C                                                                       09845000
C     ON RETURN                                                         09846000
C                                                                       09847000
C        B       THE SOLUTION VECTOR  X .                               09848000
C                                                                       09849000
C     ERROR CONDITION                                                   09850000
C                                                                       09851000
C        A DIVISION BY ZERO WILL OCCUR IF THE INPUT FACTOR CONTAINS A   09852000
C        ZERO ON THE DIAGONAL.  TECHNICALLY THIS INDICATES SINGULARITY  09853000
C        BUT IT IS OFTEN CAUSED BY IMPROPER ARGUMENTS OR IMPROPER       09854000
C        SETTING OF LDA .  IT WILL NOT OCCUR IF THE SUBROUTINES ARE     09855000
C        CALLED CORRECTLY AND IF MDGECO HAS SET RCOND .GT. 0.0          09856000
C        OR MDGEFA HAS SET INFO .EQ. 0 .                                09857000
C                                                                       09858000
C     TO COMPUTE  INVERSE(A) * C  WHERE  C  IS A MATRIX                 09859000
C     WITH  P  COLUMNS                                                  09860000
C           CALL MDGECO(A,LDA,N,IPVT,RCOND,Z)                           09861000
C           IF (RCOND IS TOO SMALL) GO TO ...                           09862000
C           DO 10 J = 1, P                                              09863000
C              CALL MDGESL(A,LDA,N,IPVT,C(1,J),0)                       09864000
C        10 CONTINUE                                                    09865000
C                                                                       09866000
C     LINPACK. THIS VERSION DATED 08/14/78 .                            09867000
C     CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LAB.      09868000
C                                                                       09869000
C     SUBROUTINES AND FUNCTIONS                                         09870000
C                                                                       09871000
C     BLAS MDAXPY,MDDOT                                                 09872000
C                                                                       09873000
C     INTERNAL VARIABLES                                                09874000
C                                                                       09875000
      DOUBLE PRECISION MDDOT,T                                          09876000
      INTEGER K,KB,L,NM1                                                09877000
C                                                                       09878000
      NM1 = N - 1                                                       09879000
      IF (JOB .NE. 0) GO TO 50                                          09880000
C                                                                       09881000
C        JOB = 0 , SOLVE  A * X = B                                     09882000
C        FIRST SOLVE  L*Y = B                                           09883000
C                                                                       09884000
         IF (NM1 .LT. 1) GO TO 30                                       09885000
         DO 20 K = 1, NM1                                               09886000
            L = IPVT(K)                                                 09887000
            T = B(L)                                                    09888000
            IF (L .EQ. K) GO TO 10                                      09889000
               B(L) = B(K)                                              09890000
               B(K) = T                                                 09891000
   10       CONTINUE                                                    09892000
            CALL MDAXPY(N-K,T,A(K+1,K),1,B(K+1),1)                      09893000
   20    CONTINUE                                                       09894000
   30    CONTINUE                                                       09895000
C                                                                       09896000
C        NOW SOLVE  U*X = Y                                             09897000
C                                                                       09898000
         DO 40 KB = 1, N                                                09899000
            K = N + 1 - KB                                              09900000
            B(K) = B(K)/A(K,K)                                          09901000
            T = -B(K)                                                   09902000
            CALL MDAXPY(K-1,T,A(1,K),1,B(1),1)                          09903000
   40    CONTINUE                                                       09904000
      GO TO 100                                                         09905000
   50 CONTINUE                                                          09906000
C                                                                       09907000
C        JOB = NONZERO, SOLVE  TRANS(A) * X = B                         09908000
C        FIRST SOLVE  TRANS(U)*Y = B                                    09909000
C                                                                       09910000
         DO 60 K = 1, N                                                 09911000
            T = MDDOT(K-1,A(1,K),1,B(1),1)                              09912000
            B(K) = (B(K) - T)/A(K,K)                                    09913000
   60    CONTINUE                                                       09914000
C                                                                       09915000
C        NOW SOLVE TRANS(L)*X = Y                                       09916000
C                                                                       09917000
         IF (NM1 .LT. 1) GO TO 90                                       09918000
         DO 80 KB = 1, NM1                                              09919000
            K = N - KB                                                  09920000
            B(K) = B(K) + MDDOT(N-K,A(K+1,K),1,B(K+1),1)                09921000
            L = IPVT(K)                                                 09922000
            IF (L .EQ. K) GO TO 70                                      09923000
               T = B(L)                                                 09924000
               B(L) = B(K)                                              09925000
               B(K) = T                                                 09926000
   70       CONTINUE                                                    09927000
   80    CONTINUE                                                       09928000
   90    CONTINUE                                                       09929000
  100 CONTINUE                                                          09930000
      RETURN                                                            09931000
      END                                                               09932000
C#****MDPOA1                                                            09933000
      SUBROUTINE MDPOA1(JOB,A,B,Z,DETV,LDA,N,INFO,RCOND,SNAMEI,MXNAME)  09934000
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::09935000
C* COPYRIGHT--  1981 BY SCA, INC.  ALL RIGHTS RESERVED.                 09936000
C                                                                       09937000
C  NAME     --  MDPOA1                                                  09938000
C                                                                       09939000
C  PURPOSE  --  MDPOA1 INVERTS OR COMPUTES THE DETERMINANT OF A         09940000
C               SYMMETRIC POSITIVE DEFINITE MATRIX OR SOLVE A LINEAR    09941000
C               SYSTEM (AX=B) USING CHOLESKY DECOMPOSITION              09942000
C                                                                       09943000
C  USAGE    --  CALL   MDPOA1( ... )                                    09944000
C                                                                       09945000
C  ARGUMENTS--                                                          09946000
C                                                                       09947000
C    JOB        INTEGER SCALAR, INPUT ONLY                              09948000
C               JOB = 000 CHOLESKY DECOMPOSITION ONLY                   09949000
C                   = 001 INVERSE ONLY                                  09950000
C                   = 010 DET ONLY                                      09951000
C                   = 011 INVERSE AND DET                               09952000
C                   = 100 SOLVE ONLY                                    09953000
C                   = 101 SOLVE AND INVERSE                             09954000
C                   = 110 SOLVE AND DET                                 09955000
C                   = 111 SOLVE, INVERSE, AND DET                       09956000
C                                                                       09957000
C    A          DOUBLE PRECISION ARRAY(2), INPUT/OUTPUT                 09958000
C               INPUT : THE MATRIX TO BE INVERTED                       09959000
C               OUTPUT: THE INVERTED MATRIX                             09960000
C                                                                       09961000
C    B          DOUBLE PRECISION ARRAY(1), INPUT/OUTPUT                 09962000
C               INPUT : THE B MATRIX IN THE LINEAR SYSTEM AX=B          09963000
C               OUTPUT: THE X MATRIX                                    09964000
C                                                                       09965000
C    Z          DOUBLE PRECISION ARRAY(1), OUTPUT ONLY                  09966000
C               A WORK VECTOR                                           09967000
C                                                                       09968000
C    DETV       DOUBLE PRECISION SCALAR, OUTPUT ONLY                    09969000
C               THE DETERMINANT OF THE MATRIX A                         09970000
C                                                                       09971000
C    LDA        INTEGER SCALAR, INPUT ONLY                              09972000
C               THE LEADING DIMENSION OF THE MATRIX A                   09973000
C                                                                       09974000
C    N          INTEGER SCALAR, INPUT ONLY                              09975000
C               THE ACTUAL ORDER OF THE MATRIX A                        09976000
C                                                                       09977000
C    INFO       INTEGER SCALAR, OUTPUT                                  09978000
C               INFO = 0 NO ERROR                                       09979000
C                    =-1 A IS SINGULAR                                  09980000
C                    = K THE LEADING MINOR OF ORDER K IS NOT POSITIVE   09981000
C                        DEFINITE                                       09982000
C                                                                       09983000
C    RCOND      DOUBLE PRECISION SCALAR, OUTPUT ONLY                    09984000
C               AN ESTIMATE OF THE RECIPROCAL CONDITION OF A            09985000
C                                                                       09986000
C    SNAMEI     CHARACTER*8 SCALAR, INPUT ONLY                          09987000
C               THE CALLING SUBROUTINE NAME                             09988000
C                                                                       09989000
C    MXNAME     CHARACTER*8 SCALAR, INPUT ONLY                          09990000
C               THE IDENTIFICATION FOR MATRIX A                         09991000
C                                                                       09992000
C  REMARKS  --  NONE                                                    09993000
C                                                                       09994000
C  SUBPROGRAMS  REQUIRED --                                             09995000
C               ABGPRT, ABGDIM, MDPOCO, MDPOSL, MDPODI, ABGRTN          09996000
C                                                                       09997000
C  FORTRAN FUNCTIONS REQUIRED --                                        09998000
C               MOD                                                     09999000
C                                                                       10000000
C  COMMON BLOCKS USED --                                                10001000
C               CMIOPA                                                  10002000
C                                                                       10003000
C     CMIOPA    -IPRT                                                   10004000
C                                                                       10005000
C  REFERENCES-- NONE                                                    10006000
C                                                                       10007000
C  PROGRAMMER-- LON-MU LIU                                              10008000
C                                                                       10009000
C  LAST REVISED-- DECEMBER, 1981                                        10010000
C                                                                       10011000
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::10012000
C                                                                       10013000
      INTEGER          IGORTN, INFO  , I     , JOBT  , JOB   , J     ,  10014000
     *                 LDA   , LEVOT , N                                10015000
C                                                                       10016000
      DOUBLE PRECISION A     , B     , DETV  , DET   , RCOND , Z        10017000
C-CHR                                                                   10018000
      DOUBLE PRECISION MXNAME, SNAMEI, SNAME                            10019000
C/                                                                      10020000
C+CHR                                                                   10021000
C&    CHARACTER*8      MXNAME, SNAMEI, SNAME                            10022000
C/                                                                      10023000
      COMMON / BASIC / ICMDIN, IIPT, IPRT
      DIMENSION A(LDA,N),B(N),Z(N),DET(2)                               10029000
      DATA  SNAME /6HMDPOA1/                                            10030000
C   1 CONTINUE                                                          10031000
C     DEBUG SUBCHK                                                      10032000
C     AT 1                                                              10033000
C     TRACE ON                                                          10034000
      LEVOT=0                                                           10035000
C     CALL ABGDIM(1,SNAME,LDA,N,1,1,1,1)                                10036000
C     IF(IGORTN.EQ.2) GO TO 9800                                        10037000
C                                                                       10038000
C     FACTOR A DOUBLE PRECISION POSITIVE DEFINITE MATRIX BY             10039000
C     CHOLESKY DECOMPOSITION AND ESTIMATE THE COMDITION OF              10040000
C     THE MATRIX, NOTE A=R'R                                            10041000
C                                                                       10042000
      DETV=0.D0                                                         10043000
      CALL MDPOCO(A,LDA,N,RCOND,Z,INFO)                                 10044000
      IF(INFO.EQ.0)GO TO 200                                            10045000
      WRITE(IPRT,105) MXNAME,SNAMEI,RCOND                               10046000
  105 FORMAT(                                                           10047000
     * ' ** THE LEADING MINOR OF THE MATRIX ',A6,' TO BE INVERTED ( IN' 10048000
     */'    SUBROUTINE ',A8,') IS NOT POSITIVE DEFINITE; JOB ABANDONED.'10049000
     */'    THE RCOND IS ',G16.8/1X)                                    10050000
      GO TO 9800                                                        10051000
  200 IF((1.0D0+RCOND).GT.1.0D0)GO TO 400                               10052000
      INFO=-1                                                           10053000
      WRITE(IPRT,205) MXNAME,SNAMEI,RCOND                               10054000
  205 FORMAT(                                                           10055000
     * ' ** THE MATRIX ',A6,' TO BE INVERTED ( IN SUBROUTINE ',A8,') IS'10056000
     */'    NOT POSITIVE DEFINITE; JOB ABANDONED. THE RCOND IS ',G16.8  10057000
     */1X)                                                              10058000
      GO TO 9800                                                        10059000
  400 CONTINUE                                                          10060000
      IF(JOB.EQ.0) GO TO 9800                                           10061000
      IF(JOB.LE.99) GO TO 500                                           10062000
C                                                                       10063000
C     SOLVE THE DOUBLE PRECISION SYMMETRIC POSITIVE DEFINITE SYSTEM     10064000
C                                                                       10065000
      CALL MDPOSL(A,LDA,N,B)                                            10066000
  500 CONTINUE                                                          10067000
      JOBT=MOD(JOB,100)                                                 10068000
      IF(JOBT.LE.0) GO TO 9800                                          10069000
C                                                                       10070000
C     COMPUTE THE DETERMINANT AND INVERSE OF R                          10071000
C                                                                       10072000
      CALL MDPODI(A,LDA,N,DET,JOBT)                                     10073000
      IF((JOBT/10).EQ.1) DETV=DET(1)*(10.D0**DET(2))                    10074000
      IF(MOD(JOB,10).NE.1) GO TO 9800                                   10075000
C                                                                       10076000
C     FILL THE LOWER TRIANGULAR                                         10077000
C                                                                       10078000
      DO 600 I=1,N                                                      10079000
      DO 600 J=1,I                                                      10080000
      A(I,J)=A(J,I)                                                     10081000
  600 CONTINUE                                                          10082000
 9800 CONTINUE                                                          10083000
C     IF(LEVOT.GT.0) CALL ABGRTN(SNAME)                                 10084000
      RETURN                                                            10085000
      END                                                               10086000
C#****MDPOCO                                                            10087000
      SUBROUTINE MDPOCO(A,LDA,N,RCOND,Z,INFO)                           10088000
      INTEGER LDA,N,INFO                                                10089000
      DOUBLE PRECISION A(LDA,1),Z(1)                                    10090000
      DOUBLE PRECISION RCOND                                            10091000
C                                                                       10092000
C     MDPOCO FACTORS A DOUBLE PRECISION SYMMETRIC POSITIVE DEFINITE     10093000
C     MATRIX AND ESTIMATES THE CONDITION OF THE MATRIX.                 10094000
C                                                                       10095000
C     IF  RCOND  IS NOT NEEDED, MDPOFA IS SLIGHTLY FASTER.              10096000
C     TO SOLVE  A*X = B , FOLLOW MDPOCO BY MDPOSL.                      10097000
C     TO COMPUTE  INVERSE(A)*C , FOLLOW MDPOCO BY MDPOSL.               10098000
C     TO COMPUTE  DETERMINANT(A) , FOLLOW MDPOCO BY MDPODI.             10099000
C     TO COMPUTE  INVERSE(A) , FOLLOW MDPOCO BY MDPODI.                 10100000
C                                                                       10101000
C     ON ENTRY                                                          10102000
C                                                                       10103000
C        A       DOUBLE PRECISION(LDA, N)                               10104000
C                THE SYMMETRIC MATRIX TO BE FACTORED.  ONLY THE         10105000
C                DIAGONAL AND UPPER TRIANGLE ARE USED.                  10106000
C                                                                       10107000
C        LDA     INTEGER                                                10108000
C                THE LEADING DIMENSION OF THE ARRAY  A .                10109000
C                                                                       10110000
C        N       INTEGER                                                10111000
C                THE ORDER OF THE MATRIX  A .                           10112000
C                                                                       10113000
C     ON RETURN                                                         10114000
C                                                                       10115000
C        A       AN UPPER TRIANGULAR MATRIX  R  SO THAT  A = TRANS(R)*R 10116000
C                WHERE  TRANS(R)  IS THE TRANSPOSE.                     10117000
C                THE STRICT LOWER TRIANGLE IS UNALTERED.                10118000
C                IF  INFO .NE. 0 , THE FACTORIZATION IS NOT COMPLETE.   10119000
C                                                                       10120000
C        RCOND   DOUBLE PRECISION                                       10121000
C                AN ESTIMATE OF THE RECIPROCAL CONDITION OF  A .        10122000
C                FOR THE SYSTEM  A*X = B , RELATIVE PERTURBATIONS       10123000
C                IN  A  AND  B  OF SIZE  EPSILON  MAY CAUSE             10124000
C                RELATIVE PERTURBATIONS IN  X  OF SIZE  EPSILON/RCOND . 10125000
C                IF  RCOND  IS SO SMALL THAT THE LOGICAL EXPRESSION     10126000
C                           1.0 + RCOND .EQ. 1.0                        10127000
C                IS TRUE, THEN  A  MAY BE SINGULAR TO WORKING           10128000
C                PRECISION.  IN PARTICULAR,  RCOND  IS ZERO  IF         10129000
C                EXACT SINGULARITY IS DETECTED OR THE ESTIMATE          10130000
C                UNDERFLOWS.  IF INFO .NE. 0 , RCOND IS UNCHANGED.      10131000
C                                                                       10132000
C        Z       DOUBLE PRECISION(N)                                    10133000
C                A WORK VECTOR WHOSE CONTENTS ARE USUALLY UNIMPORTANT.  10134000
C                IF  A  IS CLOSE TO A SINGULAR MATRIX, THEN  Z  IS      10135000
C                AN APPROXIMATE NULL VECTOR IN THE SENSE THAT           10136000
C                NORM(A*Z) = RCOND*NORM(A)*NORM(Z) .                    10137000
C                IF  INFO .NE. 0 , Z  IS UNCHANGED.                     10138000
C                                                                       10139000
C        INFO    INTEGER                                                10140000
C                = 0  FOR NORMAL RETURN.                                10141000
C                = K  SIGNALS AN ERROR CONDITION.  THE LEADING MINOR    10142000
C                     OF ORDER  K  IS NOT POSITIVE DEFINITE.            10143000
C                                                                       10144000
C     LINPACK.  THIS VERSION DATED 08/14/78 .                           10145000
C     CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LAB.      10146000
C                                                                       10147000
C     SUBROUTINES AND FUNCTIONS                                         10148000
C                                                                       10149000
C     LINPACK MDPOFA                                                    10150000
C     BLAS MDAXPY,MDDOT,MDSCAL,MDASUM                                   10151000
C     FORTRAN DABS,DMAX1,DREAL,DSIGN                                    10152000
C                                                                       10153000
C     INTERNAL VARIABLES                                                10154000
C                                                                       10155000
      DOUBLE PRECISION MDDOT,EK,T,WK,WKM                                10156000
      DOUBLE PRECISION ANORM,S,MDASUM,SM,YNORM                          10157000
      INTEGER I,J,JM1,K,KB,KP1                                          10158000
C                                                                       10159000
C                                                                       10160000
C     FIND NORM OF A USING ONLY UPPER HALF                              10161000
C                                                                       10162000
      DO 30 J = 1, N                                                    10163000
         Z(J) = MDASUM(J,A(1,J),1)                                      10164000
         JM1 = J - 1                                                    10165000
         IF (JM1 .LT. 1) GO TO 20                                       10166000
         DO 10 I = 1, JM1                                               10167000
            Z(I) = Z(I) + DABS(A(I,J))                                  10168000
   10    CONTINUE                                                       10169000
   20    CONTINUE                                                       10170000
   30 CONTINUE                                                          10171000
      ANORM = 0.0D0                                                     10172000
      DO 40 J = 1, N                                                    10173000
         ANORM = DMAX1(ANORM,Z(J))                                      10174000
   40 CONTINUE                                                          10175000
C                                                                       10176000
C     FACTOR                                                            10177000
C                                                                       10178000
      CALL MDPOFA(A,LDA,N,INFO)                                         10179000
      IF (INFO .NE. 0) GO TO 180                                        10180000
C                                                                       10181000
C        RCOND = 1/(NORM(A)*(ESTIMATE OF NORM(INVERSE(A)))) .           10182000
C        ESTIMATE = NORM(Z)/NORM(Y) WHERE  A*Z = Y  AND  A*Y = E .      10183000
C        THE COMPONENTS OF  E  ARE CHOSEN TO CAUSE MAXIMUM LOCAL        10184000
C        GROWTH IN THE ELEMENTS OF W  WHERE  TRANS(R)*W = E .           10185000
C        THE VECTORS ARE FREQUENTLY RESCALED TO AVOID OVERFLOW.         10186000
C                                                                       10187000
C        SOLVE TRANS(R)*W = E                                           10188000
C                                                                       10189000
         EK = 1.0D0                                                     10190000
         DO 50 J = 1, N                                                 10191000
            Z(J) = 0.0D0                                                10192000
   50    CONTINUE                                                       10193000
         DO 110 K = 1, N                                                10194000
            IF (Z(K) .NE. 0.0D0) EK = DSIGN(EK,-Z(K))                   10195000
            IF (DABS(EK-Z(K)) .LE. A(K,K)) GO TO 60                     10196000
               S = A(K,K)/DABS(EK-Z(K))                                 10197000
               CALL MDSCAL(N,S,Z,1)                                     10198000
               EK = S*EK                                                10199000
   60       CONTINUE                                                    10200000
            WK = EK - Z(K)                                              10201000
            WKM = -EK - Z(K)                                            10202000
            S = DABS(WK)                                                10203000
            SM = DABS(WKM)                                              10204000
            WK = WK/A(K,K)                                              10205000
            WKM = WKM/A(K,K)                                            10206000
            KP1 = K + 1                                                 10207000
            IF (KP1 .GT. N) GO TO 100                                   10208000
               DO 70 J = KP1, N                                         10209000
                  SM = SM + DABS(Z(J)+WKM*A(K,J))                       10210000
                  Z(J) = Z(J) + WK*A(K,J)                               10211000
                  S = S + DABS(Z(J))                                    10212000
   70          CONTINUE                                                 10213000
               IF (S .GE. SM) GO TO 90                                  10214000
                  T = WKM - WK                                          10215000
                  WK = WKM                                              10216000
                  DO 80 J = KP1, N                                      10217000
                     Z(J) = Z(J) + T*A(K,J)                             10218000
   80             CONTINUE                                              10219000
   90          CONTINUE                                                 10220000
  100       CONTINUE                                                    10221000
            Z(K) = WK                                                   10222000
  110    CONTINUE                                                       10223000
         S = 1.0D0/MDASUM(N,Z,1)                                        10224000
         CALL MDSCAL(N,S,Z,1)                                           10225000
C                                                                       10226000
C        SOLVE R*Y = W                                                  10227000
C                                                                       10228000
         DO 130 KB = 1, N                                               10229000
            K = N + 1 - KB                                              10230000
            IF (DABS(Z(K)) .LE. A(K,K)) GO TO 120                       10231000
               S = A(K,K)/DABS(Z(K))                                    10232000
               CALL MDSCAL(N,S,Z,1)                                     10233000
  120       CONTINUE                                                    10234000
            Z(K) = Z(K)/A(K,K)                                          10235000
            T = -Z(K)                                                   10236000
            CALL MDAXPY(K-1,T,A(1,K),1,Z(1),1)                          10237000
  130    CONTINUE                                                       10238000
         S = 1.0D0/MDASUM(N,Z,1)                                        10239000
         CALL MDSCAL(N,S,Z,1)                                           10240000
C                                                                       10241000
         YNORM = 1.0D0                                                  10242000
C                                                                       10243000
C        SOLVE TRANS(R)*V = Y                                           10244000
C                                                                       10245000
         DO 150 K = 1, N                                                10246000
            Z(K) = Z(K) - MDDOT(K-1,A(1,K),1,Z(1),1)                    10247000
            IF (DABS(Z(K)) .LE. A(K,K)) GO TO 140                       10248000
               S = A(K,K)/DABS(Z(K))                                    10249000
               CALL MDSCAL(N,S,Z,1)                                     10250000
               YNORM = S*YNORM                                          10251000
  140       CONTINUE                                                    10252000
            Z(K) = Z(K)/A(K,K)                                          10253000
  150    CONTINUE                                                       10254000
         S = 1.0D0/MDASUM(N,Z,1)                                        10255000
         CALL MDSCAL(N,S,Z,1)                                           10256000
         YNORM = S*YNORM                                                10257000
C                                                                       10258000
C        SOLVE R*Z = V                                                  10259000
C                                                                       10260000
         DO 170 KB = 1, N                                               10261000
            K = N + 1 - KB                                              10262000
            IF (DABS(Z(K)) .LE. A(K,K)) GO TO 160                       10263000
               S = A(K,K)/DABS(Z(K))                                    10264000
               CALL MDSCAL(N,S,Z,1)                                     10265000
               YNORM = S*YNORM                                          10266000
  160       CONTINUE                                                    10267000
            Z(K) = Z(K)/A(K,K)                                          10268000
            T = -Z(K)                                                   10269000
            CALL MDAXPY(K-1,T,A(1,K),1,Z(1),1)                          10270000
  170    CONTINUE                                                       10271000
C        MAKE ZNORM = 1.0                                               10272000
         S = 1.0D0/MDASUM(N,Z,1)                                        10273000
         CALL MDSCAL(N,S,Z,1)                                           10274000
         YNORM = S*YNORM                                                10275000
C                                                                       10276000
         IF (ANORM .NE. 0.0D0) RCOND = YNORM/ANORM                      10277000
         IF (ANORM .EQ. 0.0D0) RCOND = 0.0D0                            10278000
  180 CONTINUE                                                          10279000
      RETURN                                                            10280000
      END                                                               10281000
C#****MDPODI                                                            10282000
      SUBROUTINE MDPODI(A,LDA,N,DET,JOB)                                10283000
      INTEGER LDA,N,JOB                                                 10284000
      DOUBLE PRECISION A(LDA,1)                                         10285000
      DOUBLE PRECISION DET(2)                                           10286000
C                                                                       10287000
C     MDPODI COMPUTES THE DETERMINANT AND INVERSE OF A CERTAIN          10288000
C     DOUBLE PRECISION SYMMETRIC POSITIVE DEFINITE MATRIX (SEE BELOW)   10289000
C     USING THE FACTORS COMPUTED BY MDPOCO, MDPOFA OR DQRDC.            10290000
C                                                                       10291000
C     ON ENTRY                                                          10292000
C                                                                       10293000
C        A       DOUBLE PRECISION(LDA, N)                               10294000
C                THE OUTPUT  A  FROM MDPOCO OR MDPOFA                   10295000
C                OR THE OUTPUT  X  FROM DQRDC.                          10296000
C                                                                       10297000
C        LDA     INTEGER                                                10298000
C                THE LEADING DIMENSION OF THE ARRAY  A .                10299000
C                                                                       10300000
C        N       INTEGER                                                10301000
C                THE ORDER OF THE MATRIX  A .                           10302000
C                                                                       10303000
C        JOB     INTEGER                                                10304000
C                = 11   BOTH DETERMINANT AND INVERSE.                   10305000
C                = 01   INVERSE ONLY.                                   10306000
C                = 10   DETERMINANT ONLY.                               10307000
C                                                                       10308000
C     ON RETURN                                                         10309000
C                                                                       10310000
C        A       IF MDPOCO OR MDPOFA WAS USED TO FACTOR  A  THEN        10311000
C                MDPODI PRODUCES THE UPPER HALF OF INVERSE(A) .         10312000
C                IF DQRDC WAS USED TO DECOMPOSE  X  THEN                10313000
C                MDPODI PRODUCES THE UPPER HALF OF INVERSE(TRANS(X)*X)  10314000
C                WHERE TRANS(X) IS THE TRANSPOSE.                       10315000
C                ELEMENTS OF  A  BELOW THE DIAGONAL ARE UNCHANGED.      10316000
C                IF THE UNITS DIGIT OF JOB IS ZERO,  A  IS UNCHANGED.   10317000
C                                                                       10318000
C        DET     DOUBLE PRECISION(2)                                    10319000
C                DETERMINANT OF  A  OR OF  TRANS(X)*X  IF REQUESTED.    10320000
C                OTHERWISE NOT REFERENCED.                              10321000
C                DETERMINANT = DET(1) * 10.0**DET(2)                    10322000
C                WITH  1.0 .LE. DET(1) .LT. 10.0                        10323000
C                OR  DET(1) .EQ. 0.0 .                                  10324000
C                                                                       10325000
C     ERROR CONDITION                                                   10326000
C                                                                       10327000
C        A DIVISION BY ZERO WILL OCCUR IF THE INPUT FACTOR CONTAINS     10328000
C        A ZERO ON THE DIAGONAL AND THE INVERSE IS REQUESTED.           10329000
C        IT WILL NOT OCCUR IF THE SUBROUTINES ARE CALLED CORRECTLY      10330000
C        AND IF MDPOCO OR MDPOFA HAS SET INFO .EQ. 0 .                  10331000
C                                                                       10332000
C     LINPACK.  THIS VERSION DATED 08/14/78 .                           10333000
C     CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LAB.      10334000
C                                                                       10335000
C     SUBROUTINES AND FUNCTIONS                                         10336000
C                                                                       10337000
C     BLAS MDAXPY,MDSCAL                                                10338000
C     FORTRAN MOD                                                       10339000
C                                                                       10340000
C     INTERNAL VARIABLES                                                10341000
C                                                                       10342000
      DOUBLE PRECISION T                                                10343000
      DOUBLE PRECISION S                                                10344000
      INTEGER I,J,JM1,K,KP1                                             10345000
C                                                                       10346000
C     COMPUTE DETERMINANT                                               10347000
C                                                                       10348000
      IF (JOB/10 .EQ. 0) GO TO 70                                       10349000
         DET(1) = 1.0D0                                                 10350000
         DET(2) = 0.0D0                                                 10351000
         S = 10.0D0                                                     10352000
         DO 50 I = 1, N                                                 10353000
            DET(1) = A(I,I)**2*DET(1)                                   10354000
C        ...EXIT                                                        10355000
            IF (DET(1) .EQ. 0.0D0) GO TO 60                             10356000
   10       IF (DET(1) .GE. 1.0D0) GO TO 20                             10357000
               DET(1) = S*DET(1)                                        10358000
               DET(2) = DET(2) - 1.0D0                                  10359000
            GO TO 10                                                    10360000
   20       CONTINUE                                                    10361000
   30       IF (DET(1) .LT. S) GO TO 40                                 10362000
               DET(1) = DET(1)/S                                        10363000
               DET(2) = DET(2) + 1.0D0                                  10364000
            GO TO 30                                                    10365000
   40       CONTINUE                                                    10366000
   50    CONTINUE                                                       10367000
   60    CONTINUE                                                       10368000
   70 CONTINUE                                                          10369000
C                                                                       10370000
C     COMPUTE INVERSE(R)                                                10371000
C                                                                       10372000
      IF (MOD(JOB,10) .EQ. 0) GO TO 140                                 10373000
         DO 100 K = 1, N                                                10374000
            A(K,K) = 1.0D0/A(K,K)                                       10375000
            T = -A(K,K)                                                 10376000
            CALL MDSCAL(K-1,T,A(1,K),1)                                 10377000
            KP1 = K + 1                                                 10378000
            IF (N .LT. KP1) GO TO 90                                    10379000
            DO 80 J = KP1, N                                            10380000
               T = A(K,J)                                               10381000
               A(K,J) = 0.0D0                                           10382000
               CALL MDAXPY(K,T,A(1,K),1,A(1,J),1)                       10383000
   80       CONTINUE                                                    10384000
   90       CONTINUE                                                    10385000
  100    CONTINUE                                                       10386000
C                                                                       10387000
C        FORM  INVERSE(R) * TRANS(INVERSE(R))                           10388000
C                                                                       10389000
         DO 130 J = 1, N                                                10390000
            JM1 = J - 1                                                 10391000
            IF (JM1 .LT. 1) GO TO 120                                   10392000
            DO 110 K = 1, JM1                                           10393000
               T = A(K,J)                                               10394000
               CALL MDAXPY(K,T,A(1,J),1,A(1,K),1)                       10395000
  110       CONTINUE                                                    10396000
  120       CONTINUE                                                    10397000
            T = A(J,J)                                                  10398000
            CALL MDSCAL(J,T,A(1,J),1)                                   10399000
  130    CONTINUE                                                       10400000
  140 CONTINUE                                                          10401000
      RETURN                                                            10402000
      END                                                               10403000
C#****MDPOFA                                                            10404000
      SUBROUTINE MDPOFA(A,LDA,N,INFO)                                   10405000
      INTEGER LDA,N,INFO                                                10406000
      DOUBLE PRECISION A(LDA,1)                                         10407000
C                                                                       10408000
C     MDPOFA FACTORS A DOUBLE PRECISION SYMMETRIC POSITIVE DEFINITE     10409000
C     MATRIX.                                                           10410000
C                                                                       10411000
C     MDPOFA IS USUALLY CALLED BY MDPOCO, BUT IT CAN BE CALLED          10412000
C     DIRECTLY WITH A SAVING IN TIME IF  RCOND  IS NOT NEEDED.          10413000
C     (TIME FOR MDPOCO) = (1 + 18/N)*(TIME FOR MDPOFA) .                10414000
C                                                                       10415000
C     ON ENTRY                                                          10416000
C                                                                       10417000
C        A       DOUBLE PRECISION(LDA, N)                               10418000
C                THE SYMMETRIC MATRIX TO BE FACTORED.  ONLY THE         10419000
C                DIAGONAL AND UPPER TRIANGLE ARE USED.                  10420000
C                                                                       10421000
C        LDA     INTEGER                                                10422000
C                THE LEADING DIMENSION OF THE ARRAY  A .                10423000
C                                                                       10424000
C        N       INTEGER                                                10425000
C                THE ORDER OF THE MATRIX  A .                           10426000
C                                                                       10427000
C     ON RETURN                                                         10428000
C                                                                       10429000
C        A       AN UPPER TRIANGULAR MATRIX  R  SO THAT  A = TRANS(R)*R 10430000
C                WHERE  TRANS(R)  IS THE TRANSPOSE.                     10431000
C                THE STRICT LOWER TRIANGLE IS UNALTERED.                10432000
C                IF  INFO .NE. 0 , THE FACTORIZATION IS NOT COMPLETE.   10433000
C                                                                       10434000
C        INFO    INTEGER                                                10435000
C                = 0  FOR NORMAL RETURN.                                10436000
C                = K  SIGNALS AN ERROR CONDITION.  THE LEADING MINOR    10437000
C                     OF ORDER  K  IS NOT POSITIVE DEFINITE.            10438000
C                                                                       10439000
C     LINPACK.  THIS VERSION DATED 08/14/78 .                           10440000
C     CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LAB.      10441000
C                                                                       10442000
C     SUBROUTINES AND FUNCTIONS                                         10443000
C                                                                       10444000
C     BLAS MDDOT                                                        10445000
C     FORTRAN DSQRT                                                     10446000
C                                                                       10447000
C     INTERNAL VARIABLES                                                10448000
C                                                                       10449000
      DOUBLE PRECISION MDDOT,T                                          10450000
      DOUBLE PRECISION S                                                10451000
      INTEGER J,JM1,K                                                   10452000
C     BEGIN BLOCK WITH ...EXITS TO 40                                   10453000
C                                                                       10454000
C                                                                       10455000
         DO 30 J = 1, N                                                 10456000
            INFO = J                                                    10457000
            S = 0.0D0                                                   10458000
            JM1 = J - 1                                                 10459000
            IF (JM1 .LT. 1) GO TO 20                                    10460000
            DO 10 K = 1, JM1                                            10461000
               T = A(K,J) - MDDOT(K-1,A(1,K),1,A(1,J),1)                10462000
               T = T/A(K,K)                                             10463000
               A(K,J) = T                                               10464000
               S = S + T*T                                              10465000
   10       CONTINUE                                                    10466000
   20       CONTINUE                                                    10467000
            S = A(J,J) - S                                              10468000
C     ......EXIT                                                        10469000
            IF (S .LE. 0.0D0) GO TO 40                                  10470000
            A(J,J) = DSQRT(S)                                           10471000
   30    CONTINUE                                                       10472000
         INFO = 0                                                       10473000
   40 CONTINUE                                                          10474000
      RETURN                                                            10475000
      END                                                               10476000
C#****MDPOSL                                                            10477000
      SUBROUTINE MDPOSL(A,LDA,N,B)                                      10478000
      INTEGER LDA,N                                                     10479000
      DOUBLE PRECISION A(LDA,1),B(1)                                    10480000
C                                                                       10481000
C     MDPOSL SOLVES THE DOUBLE PRECISION SYMMETRIC POSITIVE DEFINITE    10482000
C     SYSTEM A * X = B                                                  10483000
C     USING THE FACTORS COMPUTED BY MDPOCO OR MDPOFA.                   10484000
C                                                                       10485000
C     ON ENTRY                                                          10486000
C                                                                       10487000
C        A       DOUBLE PRECISION(LDA, N)                               10488000
C                THE OUTPUT FROM MDPOCO OR MDPOFA.                      10489000
C                                                                       10490000
C        LDA     INTEGER                                                10491000
C                THE LEADING DIMENSION OF THE ARRAY  A .                10492000
C                                                                       10493000
C        N       INTEGER                                                10494000
C                THE ORDER OF THE MATRIX  A .                           10495000
C                                                                       10496000
C        B       DOUBLE PRECISION(N)                                    10497000
C                THE RIGHT HAND SIDE VECTOR.                            10498000
C                                                                       10499000
C     ON RETURN                                                         10500000
C                                                                       10501000
C        B       THE SOLUTION VECTOR  X .                               10502000
C                                                                       10503000
C     ERROR CONDITION                                                   10504000
C                                                                       10505000
C        A DIVISION BY ZERO WILL OCCUR IF THE INPUT FACTOR CONTAINS     10506000
C        A ZERO ON THE DIAGONAL.  TECHNICALLY THIS INDICATES            10507000
C        SINGULARITY BUT IT IS USUALLY CAUSED BY IMPROPER SUBROUTINE    10508000
C        ARGUMENTS.  IT WILL NOT OCCUR IF THE SUBROUTINES ARE CALLED    10509000
C        CORRECTLY AND  INFO .EQ. 0 .                                   10510000
C                                                                       10511000
C     TO COMPUTE  INVERSE(A) * C  WHERE  C  IS A MATRIX                 10512000
C     WITH  P  COLUMNS                                                  10513000
C           CALL MDPOCO(A,LDA,N,RCOND,Z,INFO)                           10514000
C           IF (RCOND IS TOO SMALL .OR. INFO .NE. 0) GO TO ...          10515000
C           DO 10 J = 1, P                                              10516000
C              CALL MDPOSL(A,LDA,N,C(1,J))                              10517000
C        10 CONTINUE                                                    10518000
C                                                                       10519000
C     LINPACK.  THIS VERSION DATED 08/14/78 .                           10520000
C     CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LAB.      10521000
C                                                                       10522000
C     SUBROUTINES AND FUNCTIONS                                         10523000
C                                                                       10524000
C     BLAS MDAXPY,MDDOT                                                 10525000
C                                                                       10526000
C     INTERNAL VARIABLES                                                10527000
C                                                                       10528000
      DOUBLE PRECISION MDDOT,T                                          10529000
      INTEGER K,KB                                                      10530000
C                                                                       10531000
C     SOLVE TRANS(R)*Y = B                                              10532000
C                                                                       10533000
      DO 10 K = 1, N                                                    10534000
         T = MDDOT(K-1,A(1,K),1,B(1),1)                                 10535000
         B(K) = (B(K) - T)/A(K,K)                                       10536000
   10 CONTINUE                                                          10537000
C                                                                       10538000
C     SOLVE R*X = Y                                                     10539000
C                                                                       10540000
      DO 20 KB = 1, N                                                   10541000
         K = N + 1 - KB                                                 10542000
         B(K) = B(K)/A(K,K)                                             10543000
         T = -B(K)                                                      10544000
         CALL MDAXPY(K-1,T,A(1,K),1,B(1),1)                             10545000
   20 CONTINUE                                                          10546000
      RETURN                                                            10547000
      END                                                               10548000
C#****MDSCAL                                                            10549000
      SUBROUTINE  MDSCAL(N,DA,DX,INCX)                                  10550000
C                                                                       10551000
C     SCALES A VECTOR BY A CONSTANT.                                    10552000
C     USES UNROLLED LOOPS FOR INCREMENT EQUAL TO ONE.                   10553000
C     JACK DONGARRA, LINPACK, 3/11/78.                                  10554000
C                                                                       10555000
      DOUBLE PRECISION DA,DX(1)                                         10556000
      INTEGER I,INCX,M,MP1,N,NINCX                                      10557000
C                                                                       10558000
      IF(N.LE.0)RETURN                                                  10559000
      IF(INCX.EQ.1)GO TO 20                                             10560000
C                                                                       10561000
C        CODE FOR INCREMENT NOT EQUAL TO 1                              10562000
C                                                                       10563000
      NINCX = N*INCX                                                    10564000
      DO 10 I = 1,NINCX,INCX                                            10565000
        DX(I) = DA*DX(I)                                                10566000
   10 CONTINUE                                                          10567000
      RETURN                                                            10568000
C                                                                       10569000
C        CODE FOR INCREMENT EQUAL TO 1                                  10570000
C                                                                       10571000
C                                                                       10572000
C        CLEAN-UP LOOP                                                  10573000
C                                                                       10574000
   20 M = MOD(N,5)                                                      10575000
      IF( M .EQ. 0 ) GO TO 40                                           10576000
      DO 30 I = 1,M                                                     10577000
        DX(I) = DA*DX(I)                                                10578000
   30 CONTINUE                                                          10579000
      IF( N .LT. 5 ) RETURN                                             10580000
   40 MP1 = M + 1                                                       10581000
      DO 50 I = MP1,N,5                                                 10582000
        DX(I) = DA*DX(I)                                                10583000
        DX(I + 1) = DA*DX(I + 1)                                        10584000
        DX(I + 2) = DA*DX(I + 2)                                        10585000
        DX(I + 3) = DA*DX(I + 3)                                        10586000
        DX(I + 4) = DA*DX(I + 4)                                        10587000
   50 CONTINUE                                                          10588000
      RETURN                                                            10589000
      END                                                               10590000
C#****MDSWAP                                                            10591000
      SUBROUTINE  MDSWAP (N,DX,INCX,DY,INCY)                            10592000
C                                                                       10593000
C     INTERCHANGES TWO VECTORS.                                         10594000
C     USES UNROLLED LOOPS FOR INCREMENTS EQUAL ONE.                     10595000
C     JACK DONGARRA, LINPACK, 3/11/78.                                  10596000
C                                                                       10597000
      DOUBLE PRECISION DX(1),DY(1),DTEMP                                10598000
      INTEGER I,INCX,INCY,IX,IY,M,MP1,N                                 10599000
C                                                                       10600000
      IF(N.LE.0)RETURN                                                  10601000
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20                               10602000
C                                                                       10603000
C       CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS NOT EQUAL       10604000
C         TO 1                                                          10605000
C                                                                       10606000
      IX = 1                                                            10607000
      IY = 1                                                            10608000
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1                                 10609000
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1                                 10610000
      DO 10 I = 1,N                                                     10611000
        DTEMP = DX(IX)                                                  10612000
        DX(IX) = DY(IY)                                                 10613000
        DY(IY) = DTEMP                                                  10614000
        IX = IX + INCX                                                  10615000
        IY = IY + INCY                                                  10616000
   10 CONTINUE                                                          10617000
      RETURN                                                            10618000
C                                                                       10619000
C       CODE FOR BOTH INCREMENTS EQUAL TO 1                             10620000
C                                                                       10621000
C                                                                       10622000
C       CLEAN-UP LOOP                                                   10623000
C                                                                       10624000
   20 M = MOD(N,3)                                                      10625000
      IF( M .EQ. 0 ) GO TO 40                                           10626000
      DO 30 I = 1,M                                                     10627000
        DTEMP = DX(I)                                                   10628000
        DX(I) = DY(I)                                                   10629000
        DY(I) = DTEMP                                                   10630000
   30 CONTINUE                                                          10631000
      IF( N .LT. 3 ) RETURN                                             10632000
   40 MP1 = M + 1                                                       10633000
      DO 50 I = MP1,N,3                                                 10634000
        DTEMP = DX(I)                                                   10635000
        DX(I) = DY(I)                                                   10636000
        DY(I) = DTEMP                                                   10637000
        DTEMP = DX(I + 1)                                               10638000
        DX(I + 1) = DY(I + 1)                                           10639000
        DY(I + 1) = DTEMP                                               10640000
        DTEMP = DX(I + 2)                                               10641000
        DX(I + 2) = DY(I + 2)                                           10642000
        DY(I + 2) = DTEMP                                               10643000
   50 CONTINUE                                                          10644000
      RETURN                                                            10645000
      END                                                               10646000
C#****MDTRDI                                                            10647000
      SUBROUTINE MDTRDI(T,LDT,N,DET,JOB,INFO)                           10648000
      INTEGER LDT,N,JOB,INFO                                            10649000
      DOUBLE PRECISION T(LDT,1),DET(2)                                  10650000
C                                                                       10651000
C     MDTRDI COMPUTES THE DETERMINANT AND INVERSE OF A DOUBLE PRECISION 10652000
C     TRIANGULAR MATRIX.                                                10653000
C                                                                       10654000
C     ON ENTRY                                                          10655000
C                                                                       10656000
C        T       DOUBLE PRECISION(LDT,N)                                10657000
C                T CONTAINS THE TRIANGULAR MATRIX. THE ZERO             10658000
C                ELEMENTS OF THE MATRIX ARE NOT REFERENCED, AND         10659000
C                THE CORRESPONDING ELEMENTS OF THE ARRAY CAN BE         10660000
C                USED TO STORE OTHER INFORMATION.                       10661000
C                                                                       10662000
C        LDT     INTEGER                                                10663000
C                LDT IS THE LEADING DIMENSION OF THE ARRAY T.           10664000
C                                                                       10665000
C        N       INTEGER                                                10666000
C                N IS THE ORDER OF THE SYSTEM.                          10667000
C                                                                       10668000
C        JOB     INTEGER                                                10669000
C                = 010       NO DET, INVERSE OF LOWER TRIANGULAR.       10670000
C                = 011       NO DET, INVERSE OF UPPER TRIANGULAR.       10671000
C                = 100       DET, NO INVERSE.                           10672000
C                = 110       DET, INVERSE OF LOWER TRIANGULAR.          10673000
C                = 111       DET, INVERSE OF UPPER TRIANGULAR.          10674000
C                                                                       10675000
C     ON RETURN                                                         10676000
C                                                                       10677000
C        T       INVERSE OF ORIGINAL MATRIX IF REQUESTED.               10678000
C                OTHERWISE UNCHANGED.                                   10679000
C                                                                       10680000
C        DET     DOUBLE PRECISION(2)                                    10681000
C                DETERMINANT OF ORIGINAL MATRIX IF REQUESTED.           10682000
C                OTHERWISE NOT REFERENCED.                              10683000
C                DETERMINANT = DET(1) * 10.0**DET(2)                    10684000
C                WITH  1.0 .LE. DABS(DET(1)) .LT. 10.0                  10685000
C                OR  DET(1) .EQ. 0.0 .                                  10686000
C                                                                       10687000
C        INFO    INTEGER                                                10688000
C                INFO CONTAINS ZERO IF THE SYSTEM IS NONSINGULAR        10689000
C                AND THE INVERSE IS REQUESTED.                          10690000
C                OTHERWISE INFO CONTAINS THE INDEX OF                   10691000
C                A ZERO DIAGONAL ELEMENT OF T.                          10692000
C                                                                       10693000
C                                                                       10694000
C     LINPACK. THIS VERSION DATED 08/14/78 .                            10695000
C     CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LAB.      10696000
C                                                                       10697000
C     SUBROUTINES AND FUNCTIONS                                         10698000
C                                                                       10699000
C     BLAS MDAXPY,MDSCAL                                                10700000
C     FORTRAN DABS,MOD                                                  10701000
C                                                                       10702000
C     INTERNAL VARIABLES                                                10703000
C                                                                       10704000
      DOUBLE PRECISION TEMP                                             10705000
      DOUBLE PRECISION TEN                                              10706000
      INTEGER I,J,K,KB,KM1,KP1                                          10707000
C                                                                       10708000
C     BEGIN BLOCK PERMITTING ...EXITS TO 180                            10709000
C                                                                       10710000
C        COMPUTE DETERMINANT                                            10711000
C                                                                       10712000
         IF (JOB/100 .EQ. 0) GO TO 70                                   10713000
            DET(1) = 1.0D0                                              10714000
            DET(2) = 0.0D0                                              10715000
            TEN = 10.0D0                                                10716000
            DO 50 I = 1, N                                              10717000
               DET(1) = T(I,I)*DET(1)                                   10718000
C           ...EXIT                                                     10719000
               IF (DET(1) .EQ. 0.0D0) GO TO 60                          10720000
   10          IF (DABS(DET(1)) .GE. 1.0D0) GO TO 20                    10721000
                  DET(1) = TEN*DET(1)                                   10722000
                  DET(2) = DET(2) - 1.0D0                               10723000
               GO TO 10                                                 10724000
   20          CONTINUE                                                 10725000
   30          IF (DABS(DET(1)) .LT. TEN) GO TO 40                      10726000
                  DET(1) = DET(1)/TEN                                   10727000
                  DET(2) = DET(2) + 1.0D0                               10728000
               GO TO 30                                                 10729000
   40          CONTINUE                                                 10730000
   50       CONTINUE                                                    10731000
   60       CONTINUE                                                    10732000
   70    CONTINUE                                                       10733000
C                                                                       10734000
C        COMPUTE INVERSE OF UPPER TRIANGULAR                            10735000
C                                                                       10736000
         IF (MOD(JOB/10,10) .EQ. 0) GO TO 170                           10737000
            IF (MOD(JOB,10) .EQ. 0) GO TO 120                           10738000
C              BEGIN BLOCK PERMITTING ...EXITS TO 110                   10739000
                  DO 100 K = 1, N                                       10740000
                     INFO = K                                           10741000
C              ......EXIT                                               10742000
                     IF (T(K,K) .EQ. 0.0D0) GO TO 110                   10743000
                     T(K,K) = 1.0D0/T(K,K)                              10744000
                     TEMP = -T(K,K)                                     10745000
                     CALL MDSCAL(K-1,TEMP,T(1,K),1)                     10746000
                     KP1 = K + 1                                        10747000
                     IF (N .LT. KP1) GO TO 90                           10748000
                     DO 80 J = KP1, N                                   10749000
                        TEMP = T(K,J)                                   10750000
                        T(K,J) = 0.0D0                                  10751000
                        CALL MDAXPY(K,TEMP,T(1,K),1,T(1,J),1)           10752000
   80                CONTINUE                                           10753000
   90                CONTINUE                                           10754000
  100             CONTINUE                                              10755000
                  INFO = 0                                              10756000
  110          CONTINUE                                                 10757000
            GO TO 160                                                   10758000
  120       CONTINUE                                                    10759000
C                                                                       10760000
C              COMPUTE INVERSE OF LOWER TRIANGULAR                      10761000
C                                                                       10762000
               DO 150 KB = 1, N                                         10763000
                  K = N + 1 - KB                                        10764000
                  INFO = K                                              10765000
C     ............EXIT                                                  10766000
                  IF (T(K,K) .EQ. 0.0D0) GO TO 180                      10767000
                  T(K,K) = 1.0D0/T(K,K)                                 10768000
                  TEMP = -T(K,K)                                        10769000
                  IF (K .NE. N) CALL MDSCAL(N-K,TEMP,T(K+1,K),1)        10770000
                  KM1 = K - 1                                           10771000
                  IF (KM1 .LT. 1) GO TO 140                             10772000
                  DO 130 J = 1, KM1                                     10773000
                     TEMP = T(K,J)                                      10774000
                     T(K,J) = 0.0D0                                     10775000
                     CALL MDAXPY(N-K+1,TEMP,T(K,K),1,T(K,J),1)          10776000
  130             CONTINUE                                              10777000
  140             CONTINUE                                              10778000
  150          CONTINUE                                                 10779000
               INFO = 0                                                 10780000
  160       CONTINUE                                                    10781000
  170    CONTINUE                                                       10782000
  180 CONTINUE                                                          10783000
      RETURN                                                            10784000
      END                                                               10785000
C*****IDAMAX                                                            09014000
      INTEGER FUNCTION IDAMAX(N,DX,INCX)                                09015000
      DOUBLE PRECISION DX(1),DMAX                                       09020000
      INTEGER I,INCX,IX,N                                               09021000
      IDAMAX = 0                                                        09023000
      IF( N .LT. 1 ) RETURN                                             09024000
      IDAMAX = 1                                                        09025000
      IF(N.EQ.1)RETURN                                                  09026000
      IF(INCX.EQ.1)GO TO 20                                             09027000
      IX = 1                                                            09031000
      DMAX = DABS(DX(1))                                                09032000
      IX = IX + INCX                                                    09033000
      DO 10 I = 2,N                                                     09034000
         IF(DABS(DX(IX)).LE.DMAX) GO TO 5                               09035000
         IDAMAX = I                                                     09036000
         DMAX = DABS(DX(IX))                                            09037000
    5    IX = IX + INCX                                                 09038000
   10 CONTINUE                                                          09039000
      RETURN                                                            09040000
   20 DMAX = DABS(DX(1))                                                09044000
      DO 30 I = 2,N                                                     09045000
         IF(DABS(DX(I)).LE.DMAX) GO TO 30                               09046000
         IDAMAX = I                                                     09047000
         DMAX = DABS(DX(I))                                             09048000
   30 CONTINUE                                                          09049000
      RETURN                                                            09050000
      END                                                               09051000
C*****AVBAR3                                                            08482000
      FUNCTION AVBAR3(X,N)                                              08483000
C* COPYRIGHT--  1981 BY SCA, INC.  ALL RIGHTS RESERVED.                 08485000
      INTEGER          IGORTN, I     , LEVOT , N                        08523000
      DOUBLE PRECISION AVBAR3, X     , SUM                              08525000
C-CHR                                                                   08526000
      DOUBLE PRECISION SNAME                                            08527000
C/                                                                      08528000
C+CHR                                                                   08529000
C&    CHARACTER*8      SNAME                                            08530000
C/                                                                      08531000
      DIMENSION X(N)                                                    08532000
      DATA SNAME /6HAVBAR3  /                                           08533000
      LEVOT=0                                                           08538000
      SUM=0.D0                                                          08540000
      DO 100 I=1,N                                                      08542000
      SUM=SUM+X(I)                                                      08543000
  100 CONTINUE                                                          08544000
 9800 CONTINUE                                                          08545000
      AVBAR3=SUM/DFLOAT(N)                                              08546000
      RETURN                                                            08548000
      END                                                               08549000
C*****AVXPY3                                                            08189000
      FUNCTION AVXPY3(X,Y,XBAR,YBAR,N)                                  08190000
C* COPYRIGHT--  1981 BY SCA, INC.  ALL RIGHTS RESERVED.                 08192000
      INTEGER          IGORTN, I     , LEVOT , N                        08240000
      DOUBLE PRECISION AVXPY3, XBAR  , X     , YBAR  , Y     , SS       08242000
C-CHR                                                                   08243000
      DOUBLE PRECISION SNAME                                            08244000
C/                                                                      08245000
C+CHR                                                                   08246000
C&    CHARACTER*8      SNAME                                            08247000
C/                                                                      08248000
      DIMENSION X(N),Y(N)                                               08249000
C/                                                                      08250000
      DATA SNAME /6HAVXPY3  /                                           08251000
      LEVOT=0                                                           08256000
      SS=0.D0                                                           08258000
      DO 100 I=1,N                                                      08260000
      SS=SS+(X(I)-XBAR)*(Y(I)-YBAR)                                     08261000
  100 CONTINUE                                                          08262000
 9800 CONTINUE                                                          08263000
      AVXPY3=SS                                                         08264000
      RETURN                                                            08266000
      END                                                               08267000
C*****APRTLB                                                            07541000
      SUBROUTINE APRTLB(LEVOTT,LEVPRT,LABEL)                            07542000
C* COPYRIGHT--  1981 BY SCA, INC.  ALL RIGHTS RESERVED.                 07544000
      INTEGER          LABEL , LEVOTT, LEVPRT                           07585000
      COMMON / BASIC / ICMDIN, IIPT, IPRT
   10 FORMAT(1X,10H..LABEL =  ,I5)                                      07592000
      IF(LEVOTT.GE.LEVPRT) WRITE(IPRT,10) LABEL                         07593000
      RETURN                                                            07594000
      END                                                               07595000
C*****ACDTOW                                                            01193000
      SUBROUTINE ACDTOW(ITYPE,A,B)                                      01194000
C* COPYRIGHT--  1981 BY SCA, INC.  ALL RIGHTS RESERVED.                 01196000
      INTEGER          IBLK  , ICH   , ID    , IGORTN, II    , ITYPE ,  01243000
     *                 IT    , I     , J     , LEVOT , NCH   , NCPV1    01244000
      DOUBLE PRECISION A2    , A                                        01246000
C-CHR                                                                   01247000
      DOUBLE PRECISION B     , DSA   , SNAME                            01248000
C/                                                                      01249000
C+CHR                                                                   01250000
C&    CHARACTER*8      B     , DSA   , SNAME                            01251000
C/                                                                      01252000
      DIMENSION ICH(16),DSA(1)                                          01253000
      DOUBLE PRECISION  DMAXV , DMINV , DSML  , DEPS                    01255000
C-CHR                                                                   01256000
      DOUBLE PRECISION  DBLNK                                           01257000
C/                                                                      01258000
C+CHR                                                                   01259000
C&    CHARACTER*8       DBLNK                                           01260000
C/                                                                      01261000
      COMMON / CMDCST / DMAXV , DMINV , DSML  , DEPS  ,                 01262000
     *                  DBLNK                                           01263000
C+CHR                                                                   01265000
C&    CHARACTER*4       IBLNK                                           01266000
C/                                                                      01267000
      COMMON / CMICST / IMAXV , IBLNK , NCPV  , NCPH  ,                 01268000
     *                  NCPIW , NCPRW , NCPDW ,                         01269000
     *                  NIWPRN, NRWPDN, NRWPCN                          01270000
C+CHR                                                                   01272000
C&    CHARACTER*4       LTR                                             01273000
C/                                                                      01274000
      COMMON / CMABCD / NOL   , LTR(88)                                 01275000
      DATA  SNAME /6HACDTOW/                                            01277000
      LEVOT=0                                                           01282000
C&    CALL ABGDIM(1,SNAME,1,1,1,1,1,1)                                  01283000
      CALL AMCHRD(DBLNK,DSA(1))                                         01284000
      NCPV1=NCPV+1                                                      01286000
      ID=0                                                              01287000
      A2=DABS(A)                                                        01288000
      DO 220 J=1,NCPV                                                   01289000
      A2=A2-DFLOAT(ID)*100.D0**(NCPV1-J)                                01290000
      ID=A2/100.D0**(NCPV-J)                                            01291000
      ICH(J)=ID                                                         01292000
      IF(ID.GE.50) ICH(J)=ICH(J)-50                                     01293000
  220 CONTINUE                                                          01294000
      IBLK=0                                                            01295000
      DO 100 II=1,NCPV                                                  01296000
      I=NCPV1-II                                                        01297000
      IF(ICH(I).NE.44) GO TO 101                                        01298000
      IBLK=IBLK+1                                                       01299000
  100 CONTINUE                                                          01300000
  101 NCH=NCPV-IBLK                                                     01301000
      GO TO (110,120,130), ITYPE                                        01302000
  110 IT=0                                                              01303000
      GO TO 140                                                         01304000
  120 IT=IBLK/2                                                         01305000
      GO TO 140                                                         01306000
  130 IT=IBLK                                                           01307000
  140 CONTINUE                                                          01308000
      DO 150 I=1,NCH                                                    01309000
      IT=IT+1                                                           01310000
      ID=ICH(I)+1                                                       01311000
      IF((ID.GE.1).AND.(ID.LE.NOL)) CALL ACZPUT(DSA,IT,LTR(ID))         01312000
  150 CONTINUE                                                          01313000
 8000 CONTINUE                                                          01314000
      CALL AMCHRD(DSA(1),B)                                             01315000
      RETURN                                                            01317000
      END                                                               01318000
C*****MXPMX1                                                            11535000
      SUBROUTINE MXPMX1(CRITCL,A,LDA,NROW,NCOL,IDSHPE,TYPE,IFMT)        11536000
C* COPYRIGHT--  1981 BY SCA, INC.  ALL RIGHTS RESERVED.                 11538000
      INTEGER          IBEGN , IDSHPE, IENDT , IEND  , IFMTI , IFMT  ,  11618000
     *                 IGORTN, II    , IPTYPE, IST   , IT    , I     ,  11619000
     *                 J     , K     , LDA   , LEVOT , LIMAGE, NCOL  ,  11620000
     *                 NLOP  , NNUM  , NROW  , NWIDTH                   11621000
      REAL             TYPE                                             11623000
      DOUBLE PRECISION A     , CRITCL, DVALUE                           11625000
C-CHR                                                                   11626000
      INTEGER          ICDOT , IMAGE                                    11627000
C/                                                                      11628000
C+CHR                                                                   11629000
C&    CHARACTER*4      ICDOT , IMAGE                                    11630000
C/                                                                      11631000
C-CHR                                                                   11632000
      DOUBLE PRECISION SNAME                                            11633000
C/                                                                      11634000
C+CHR                                                                   11635000
C&    CHARACTER*8      SNAME                                            11636000
C/                                                                      11637000
      DIMENSION A(LDA,NCOL),IMAGE(140)                                  11638000
      DOUBLE PRECISION  DMAXV , DMINV , DSML  , DEPS                    11640000
C-CHR                                                                   11641000
      DOUBLE PRECISION  DBLNK                                           11642000
C/                                                                      11643000
C+CHR                                                                   11644000
C&    CHARACTER*8       DBLNK                                           11645000
C/                                                                      11646000
      COMMON / CMDCST / DMAXV , DMINV , DSML  , DEPS  ,                 11647000
     *                  DBLNK                                           11648000
C+CHR                                                                   11649000
C&    CHARACTER*4       RBLNK                                           11650000
C/                                                                      11651000
      COMMON / CMRCST / RMAXV , RMINV , RSML  , REPS  ,                 11652000
     *                  RBLNK , RXEXP , DXEXP , RMISS ,                 11653000
     *                  RTRIG                                           11654000
C+CHR                                                                   11656000
C&    CHARACTER*4       IBLNK                                           11657000
C/                                                                      11658000
      COMMON / CMICST / IMAXV , IBLNK , NCPV  , NCPH  ,                 11659000
     *                  NCPIW , NCPRW , NCPDW ,                         11660000
     *                  NIWPRN, NRWPDN, NRWPCN                          11661000
      COMMON / BASIC  / ICMDIN, IIPT  , IPRT
      DATA ICDOT /1H. /                                                 11668000
      DATA SNAME /6HMXPMX1/                                             11669000
c patches to try to get it to work with common blocks
c     ncol=80
c     lenotp=80
c     ifmt=1
c
      LEVOT=0                                                           11674000
      IPTYPE=0                                                          11677000
      IF(CRITCL.GT.DEPS) IPTYPE=1                                       11678000
      IF(CRITCL.LT.(-DEPS)) IPTYPE=-1                                   11679000
      LIMAGE=140                                                        11680000
      IFMTI=(IFMT/1000)*1000+MOD(IFMT,10)                               11681000
      NWIDTH=IFMT/1000                                                  11682000
      NNUM=(LENOTP-10)/NWIDTH                                           11683000
  105 FORMAT(1X,I3,1X,140A1)                                            11684000
  115 FORMAT(/5X,140A1)                                                 11685000
      NLOP=(NCOL-1)/NNUM+1                                              11686000
      DO 2000 II=1,NLOP                                                 11687000
      IST=(II-1)*NNUM+1                                                 11688000
      IEND=MIN0(II*NNUM,NCOL)                                           11689000
      DO 100 J=IST,IEND                                                 11693000
      IBEGN=(J-IST)*NWIDTH+1                                            11694000
      DVALUE=DFLOAT(J)+DEPS                                             11695000
      CALL ACFTOC(IBEGN,DVALUE,IFMTI,IMAGE,LIMAGE)                      11696000
  100 CONTINUE                                                          11697000
      IBEGN=IBEGN+NWIDTH-1                                              11698000
      WRITE(IPRT,115) (IMAGE(K),K=1,IBEGN)                              11699000
      IT=1                                                              11700000
      IF(IDSHPE.EQ.2) IT=IST                                            11701000
      DO 900 I=IT,NROW                                                  11702000
      DO 800 J=IST,IEND                                                 11703000
      IF(IDSHPE.EQ.1) GO TO 160                                         11704000
      IF(J.GT.I) GO TO 800                                              11705000
  160 CONTINUE                                                          11706000
      IBEGN=(J-IST)*NWIDTH+1                                            11707000
      IF(ABS(TYPE).GT.0.0) GO TO 200                                    11708000
      DVALUE=RMISS                                                      11709000
      IF(DABS(A(I,I)*A(J,J)).LE.0.D0) GO TO 300                         11710000
      DVALUE=A(I,J)/DSQRT(A(I,I)*A(J,J))                                11711000
      GO TO 300                                                         11712000
  200 CONTINUE                                                          11713000
      DVALUE=A(I,J)/DBLE(TYPE)                                          11714000
  300 CONTINUE                                                          11715000
      IF(IPTYPE.EQ.0) GO TO 400                                         11716000
      IF(DABS(DVALUE).GE.CRITCL) GO TO 400                              11717000
      IENDT=IBEGN+NWIDTH-1                                              11718000
      DO 320 K=IBEGN,IENDT                                              11719000
      IMAGE(K)=IBLNK                                                    11720000
  320 CONTINUE                                                          11721000
      IENDT=IENDT-MOD(IFMT/10,100)                                      11722000
      IMAGE(IENDT)=ICDOT                                                11723000
      GO TO 800                                                         11724000
  400 CONTINUE                                                          11725000
      CALL ACFTOC(IBEGN,DVALUE,IFMT,IMAGE,LIMAGE)                       11726000
  800 CONTINUE                                                          11727000
      IBEGN=IBEGN+NWIDTH-1                                              11728000
      WRITE(IPRT,105) I,(IMAGE(K),K=1,IBEGN)                            11729000
  900 CONTINUE                                                          11730000
 2000 CONTINUE                                                          11731000
 9800 CONTINUE                                                          11732000
      RETURN                                                            11734000
      END                                                               11735000
C*****AVDOT3                                                            08340000
      FUNCTION AVDOT3(X,Y,N)                                            08341000
C* COPYRIGHT--  1981 BY SCA, INC.  ALL RIGHTS RESERVED.                 08343000
      INTEGER          IGORTN, I     , LEVOT , N                        08385000
      DOUBLE PRECISION AVDOT3, SS    , X     , Y                        08387000
C-CHR                                                                   08388000
      DOUBLE PRECISION SNAME                                            08389000
C/                                                                      08390000
C+CHR                                                                   08391000
C&    CHARACTER*8      SNAME                                            08392000
C/                                                                      08393000
      DIMENSION X(N),Y(N)                                               08394000
      DATA SNAME /6HAVDOT3  /                                           08395000
      LEVOT=0                                                           08400000
      SS=0.D0                                                           08402000
      DO 100 I=1,N                                                      08404000
      SS=SS+X(I)*Y(I)                                                   08405000
  100 CONTINUE                                                          08406000
      AVDOT3=SS                                                         08408000
      RETURN                                                            08410000
      END                                                               08411000
C*****ACZGET
C+DEC2
C MODIFIED FOR DEC20 CONVERSION
C/
      SUBROUTINE ACZGET(A,N,IC)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C* COPYRIGHT--  1981 BY SCA, INC.  ALL RIGHTS RESERVED.
C
C  NAME     --  ACZGET
C
C  PURPOSE  --  ACZGET PLACES THE N-TH CHARACTER OF THE VECTOR 'A'
C               INTO THE FIRST CHARACTER (LEFTEST) OF 'IC'
C
C  USAGE    --  CALL   ACZGET( ... )
C
C  ARGUMENTS--
C
C    A          CHARACTER*8 ARRAY(1), INPUT ONLY
C               THE VECTOR WHERE THE CHARACTER IS TO BE PICKED
C
C    N          INTEGER SCALAR, INPUT ONLY
C               THE POSITION OF THE CHARACTER TO BE PICKED
C
C    IC         CHARACTER*4 SCALAR, OUTPUT ONLY
C               THE VARIABLE STORING THE PICKED CHARACTER
C
C  REMARKS  --  NONE
C
C  SUBPROGRAMS  REQUIRED --
C+DEC20
C               DECBYT
C/
C
C  FORTRAN FUNCTIONS REQUIRED --
C               NONE
C
C  COMMON BLOCKS USED --
C               NONE
C
C  REFERENCES-- NONE
C
C  PROGRAMMER-- LON-MU LIU
C
C  LAST REVISED-- DECEMBER, 1981
C
C  DEC20 CONVERSION -- JUN83, PAUL FORD
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C+IBM
      DIMENSION A(N)
      CHARACTER*1 A
      CHARACTER*4 IC,IB
      DATA IB/4H    /
      IC=IB
      IC(1:1)=A(N)(1:1)
C/
C+UAS
C     DIMENSION A(1)
C     DATA NCHW/4/
CC
CC    FIND THE WORD WITH THE DESIRED CHARACTER
CC
C     IWORD=((N-1)/NCHW)+1
CC
CC    FIND CHARACTER POSITION IN THE WORD
CC
C     IT=IABS(9*(N-(IWORD-1)*NCHW-1))+1
C     IC=4H
C     BITS(IC,1,9)=BITS(A(IWORD),IT,9)
C/
C
C     POSSIBLE ALTERNATIVE FOR UAS
C
C     COMPILER(STD=66)
C     DIMENSION A(1)
C     CHARACTER*1 A,IC
C     SUBSTR(IC,1,1)=SUBSTR(A,N,1)
C+U11
C     DIMENSION A(1)
C     DATA NCHW/6/
CC
CC    FIND THE WORD WITH THE DESIRED CHARACTER
CC
C     IWORD=((N-1)/NCHW)+1
CC
CC    FIND CHARACTER POSITION IN THE WORD
CC
C     IT=IABS(6*(N-(IWORD-1)*NCHW-1))
C     IC=6H
C     FLD(0,6,IC)=FLD(IT,6,A(IWORD))
C/
C+WTF
C     CHARACTER*1 ICT,IC1
C     DOUBLE PRECISION A,AA
C     DIMENSION A(1),AA(18),ICT(144)
C     EQUIVALENCE  (ICW,IC1),(AA,ICT)
C     DATA IB/4H     /
C     DATA NCHW/8/
C     IWORD=((N-1)/NCHW)+1
C     DO 10 I=1,IWORD
C  10 AA(I)=A(I)
C     ICW=IB
C     IC1=ICT(N)
C     IC=ICW
C/
C+DEC20
C     INTEGER N
C     INTEGER IC
C     INTEGER IB
C     DIMENSION A(1)
C     DATA IB / 4H      /
C     THIS USES AN ADDITIONAL ASSEMBLER SUBROUTINE, DECBYT,
C     WHICH MOVES BYTES FROM ONE POSITION TO ANOTHER.
C     DECBYT IS IN THE SOURCE FILE SCAPAC.MAC, A COLLECTION
C     OF DEC20 MACRO FORTRAN CALLABLE SUBROUTINES THE CONVERSION
C     OF SCA TO THE DEC20.
C
C     CLEAR OUT IC
C     IC=IB
C     MOVE BYTE N OF A TO BYTE ONE OF IC
C     CALL DECBYT(A,N,IC,1)
C/
      RETURN
      END
C*****ACZPUT
C+DEC20
C MODIFIED FOR DEC20 CONVERSION
C/
      SUBROUTINE ACZPUT(A,N,IC)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C* COPYRIGHT--  1981 BY SCA, INC.  ALL RIGHTS RESERVED.
C
C  NAME     --  ACZPUT
C
C  PURPOSE  --  ACZPUT PLACES THE FIRST CHARACTER IN 'IC' INTO THE N-TH
C               CHARACTER OF THE VECTOR 'A'
C
C  USAGE    --  CALL   ACZPUT( ... )
C
C  ARGUMENTS--
C
C    A          CHARACTER*8 ARRAY(1), OUTPUT ONLY
C               THE VECTOR WHERE THE CHARACTER IS TO BE STORED
C
C    N          INTEGER SCALAR, INPUT ONLY
C               THE POSITION OF THE CHARACTER TO BE STORED
C
C    IC         CHARACTER*4 SCALAR, INPUT ONLY
C               THE VARIABLE IN WHICH THE FIRST CHARACTER IS PICKED
C
C  REMARKS  --  NONE
C
C  SUBPROGRAMS  REQUIRED --
C+DEC20
C               DECBYT
C/
C
C  FORTRAN FUNCTIONS REQUIRED --
C               NONE
C
C  COMMON BLOCKS USED --
C               NONE
C
C  REFERENCES-- NONE
C
C  PROGRAMMER-- LON-MU LIU
C
C  LAST REVISED-- DECEMBER, 1981
C
C  DEC20 VERSION -- JUN83, PAUL FORD
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C+IBM
      DIMENSION A(N)
      double precision A
      integer IC
cc      CHARACTER*1 A,IC
C&      CHARACTER*8 A
C&     CHARACTER*4 IC
      A(N)=IC
C/
C+UAS
C     DIMENSION A(1)
C     DATA NCHW/4/
CC
CC    FIND THE WORD WHERE CHARACTER WILL BE PLACED
CC
C     IWORD=((N-1)/NCHW)+1
CC
CC    FIND CHARACTER POSITION IN WORD
CC
C     IT=IABS(9*(N-(IWORD-1)*NCHW-1))+1
C     BITS(A(IWORD),IT,9)=BITS(IC,1,9)
C/
C
C     POSSIBLE ALTERNATIVE
C
C     COMPILER (STD=66)
C     DIMENSION A(1)
C     CHARACTER*1 A,IC
C     SUBSTR(A,N,1)=SUBSTR(IC,1,1)
C+U11
C     DIMENSION A(1)
C     DATA NCHW/6/
CC
CC    FIND THE WORD WHERE CHARACTER WILL BE PLACED
CC
C     IWORD=((N-1)/NCHW)+1
CC
CC    FIND CHARACTER POSITION IN WORD
CC
C     IT=IABS(6*(N-(IWORD-1)*NCHW-1))
C     FLD(IT,6,A(IWORD))=FLD(0,6,IC)
C/
C+WTF
C     CHARACTER*1 ICT,IC1
C     DOUBLE PRECISION A,AA
C     DIMENSION A(1),AA(18),ICT(144)
C     EQUIVALENCE (AA,ICT),(ICW,IC1)
C     DATA NCHW/8/
C     IWORD=((N-1)/NCHW)+1
C     DO 10 I=1,IWORD
C  10 AA(I)=A(I)
C     ICW=IC
C     ICT(N)=IC1
C     DO 20 I=1,IWORD
C  20 A(I)=AA(I)
C/
C+DEC20
CC    DECBYT IS AN ROUTINE ASSEMBLER ROUTINE, SEE COMMENT FOR ACZGET
C     INTEGER N
C     INTEGER IC
C     DIMENSION A(1)
C     MOVE CHARACTER 1 IC TO CHAR. N OF A
C     CALL DECBYT(IC,1,A,N)
C/
      RETURN
      END
C*****AMCHRD                                                            00335500
      SUBROUTINE AMCHRD(AIN,AOUT)                                       00335600
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::00335700
C* COPYRIGHT--  1981 BY SCA, INC.  ALL RIGHTS RESERVED.                 00335800
C                                                                       00335900
C  NAME     --  AMCHRD                                                  00336000
C                                                                       00336100
C  PURPOSE  --  AMCHRD MOVES A DOUBLE PRECISION CHARACTER WORD TO       00336200
C               ANOTHER DOUBLE PRECISION CHARACTER WORD                 00336300
C                                                                       00336400
C  USAGE    --  CALL   AMCHRD( ... )                                    00336500
C                                                                       00336600
C  ARGUMENTS--                                                          00336700
C                                                                       00336800
C    AIN        CHARACTER*8 SCALAR, INPUT ONLY                          00336900
C               THE INPUT WORD                                          00337000
C                                                                       00337100
C    AOUT       CHARACTER*8 SCALAR, OUTPUT ONLY                         00337200
C               THE OUTPUT WORD                                         00337300
C                                                                       00337400
C  REMARKS  --  NONE                                                    00337500
C                                                                       00337600
C  SUBPROGRAMS  REQUIRED --                                             00337700
C               ACZGET, ACZPUT                                          00337800
C                                                                       00337900
C  FORTRAN FUNCTIONS REQUIRED --                                        00338000
C               NONE                                                    00338100
C                                                                       00338200
C  COMMON BLOCKS USED --                                                00338300
C               CMICST                                                  00338400
C                                                                       00338500
C     CMICST    -NCPIW                                                  00338600
C                                                                       00338700
C  REFERENCES-- NONE                                                    00338800
C                                                                       00338900
C  PROGRAMMER-- LON-MU LIU                                              00339000
C                                                                       00339100
C  LAST REVISED-- DECEMBER, 1981                                        00339200
C                                                                       00339300
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::00339400
C                                                                       00339500
      INTEGER          K     , N2                                       00339600
C-CHR                                                                   00339700
      INTEGER          IC                                               00339800
C/                                                                      00339900
C+CHR                                                                   00340000
C&    CHARACTER*4      IC                                               00340100
C/                                                                      00340200
C-CHR                                                                   00340300
      DOUBLE PRECISION AIN   , AOUT                                     00340400
C/                                                                      00340500
C+CHR                                                                   00340600
C&    CHARACTER*8      AIN   , AOUT                                     00340700
C/                                                                      00340800
C+CHR                                                                   00340900
C&    CHARACTER*4 IBLNK                                                 00341000
C/                                                                      00341100
      COMMON / CMICST / IMAXV , IBLNK , NCPV  , NCPH  ,                 00341200
     *                  NCPIW , NCPRW , NCPDW ,                         00341300
     *                  NIWPRN, NRWPDN, NRWPCN                          00341400
C-CMS                                                                   00341500
      AOUT=AIN                                                          00341600
C/                                                                      00341700
C+CMS                                                                   00341800
C&    N2=2*NCPIW                                                        00341900
C&    DO 100 K=1,N2                                                     00342000
C&    CALL ACZGET(AIN ,K,IC)                                            00342100
C&    CALL ACZPUT(AOUT,K,IC)                                            00342200
C&100 CONTINUE                                                          00342300
C/                                                                      00342400
      RETURN                                                            00342500
      END                                                               00342600
C*****ACFTOA                                                            01319000
      SUBROUTINE ACFTOA(DVALUE,IFMT,IMAGE,LIMAGE)                       01320000
C* COPYRIGHT--  1981 BY SCA, INC.  ALL RIGHTS RESERVED.                 01322000
      INTEGER          IBLK  , IDGT  , IDIGIT, IFMTYP, IFMT  , IGORTN,  01391000
     *                 IGOTYP, II    , ISCHR , IS    , ITCHR , ITER  ,  01392000
     *                 ITT   , IT    , I     , LEVOT , LIMAGE, NCBDP ,  01393000
     *                 NCBFD , NCHRS , NDGTA , NDIGIT, NEXPD , NFD   ,  01394000
     *                 NOD                                              01395000
      REAL             TV                                               01397000
      DOUBLE PRECISION ADINT , AVALUE, DVALUE, TVALUE                   01399000
C-CHR                                                                   01400000
      INTEGER          IMAGE , IBLANK, ISTAR                            01401000
C/                                                                      01402000
C+CHR                                                                   01403000
C&    CHARACTER*4      IMAGE , IBLANK, ISTAR                            01404000
C/                                                                      01405000
C-CHR                                                                   01406000
      DOUBLE PRECISION SNAME                                            01407000
C/                                                                      01408000
C+CHR                                                                   01409000
C&    CHARACTER*8      SNAME                                            01410000
C/                                                                      01411000
      DIMENSION IMAGE(LIMAGE),ISCHR(20)                                 01412000
      DOUBLE PRECISION  DMAXV , DMINV , DSML  , DEPS                    01414000
C-CHR                                                                   01415000
      DOUBLE PRECISION  DBLNK                                           01416000
C/                                                                      01417000
C+CHR                                                                   01418000
C&    CHARACTER*8       DBLNK                                           01419000
C/                                                                      01420000
      COMMON / CMDCST / DMAXV , DMINV , DSML  , DEPS  ,                 01421000
     *                  DBLNK                                           01422000
C+CHR                                                                   01423000
C&    CHARACTER*4       RBLNK                                           01424000
C/                                                                      01425000
      COMMON / CMRCST / RMAXV , RMINV , RSML  , REPS  ,                 01426000
     *                  RBLNK , RXEXP , DXEXP , RMISS ,                 01427000
     *                  RTRIG                                           01428000
C+CHR                                                                   01429000
C&    CHARACTER*4       LTR                                             01430000
C/                                                                      01431000
      COMMON / CMABCD / NOL   , LTR(88)                                 01432000
      COMMON / BASIC / ICMDIN, IIPT, IPRT
      DATA  IBLANK/4H      /                                            01439000
      DATA  ISTAR /1H*     /                                            01440000
      DATA  SNAME /6HACFTOA/                                            01441000
      LEVOT=0                                                           01446000
      ITER=1                                                            01449000
      IFMTT=IABS(IFMT)                                                  01450000
      IFMTYP=MOD(IFMTT,10)                                              01451000
      NOD=MOD(IFMTT,1000)/10                                            01452000
      NFD=IFMTT/1000                                                    01453000
      NFDALL=NFD                                                        01454000
      TVALUE=RMISS                                                      01458000
      DO 800 I=1,LIMAGE                                                 01459000
      IMAGE(I)=IBLANK                                                   01460000
  800 CONTINUE                                                          01461000
      IF(DABS(DVALUE-TVALUE).LE.0.1D0 .OR.                              01462000
     *   DABS(DVALUE-2.D0*TVALUE).LE.0.1D0) GO TO 8000                  01463000
      IF(DABS(DVALUE).GE.DMAXV) GO TO 8000                              01464000
      IF(IFMTYP.LE.3) GO TO 6000                                        01465000
      AVALUE=DABS(DVALUE)                                               01471000
      IF(IFMTYP.NE.4) GO TO 900                                         01472000
      IF((AVALUE.LE.(10.D0**(-NOD-9))) .OR.                             01476000
     *   (AVALUE.GE.(10.D0**(-NOD)))) GO TO 900                         01476100
      IF(NFD.LE.6) GO TO 900                                            01477000
      IFMTYP=5                                                          01478000
      NOD=NFD-6                                                         01479000
      IF(DVALUE.LT.0.D0) NOD=NOD-1                                      01480000
  900 CONTINUE                                                          01481000
 1005 FORMAT(1X,3F20.6/1X,10I4)                                         01482000
      IF(IFMTYP.NE.5) GO TO 3000                                        01483000
 2000 CONTINUE                                                          01484000
      IDIGIT=0                                                          01489000
      IF(AVALUE.LE.DSML) GO TO 2200                                     01490000
      TVALUE=DLOG10(AVALUE)                                             01491000
      IDIGIT=DLOG10(AVALUE)+1.D0+DSIGN(0.0001D0,TVALUE)                 01492100
      IF(AVALUE.LT.0.1) IDIGIT=IDIGIT-1                                 01495000
      AVALUE=AVALUE/(10.D0**IDIGIT)                                     01496000
 2200 TV=IABS(IDIGIT)                                                   01497000
      NEXPD=0                                                           01498000
      IF(TV.GT.0.1) NEXPD=ALOG10(TV)+REPS                               01499000
      NEXPD=MAX0(2,NEXPD)                                               01500000
      IDGT=IABS(IDIGIT)                                                 01504000
      II=0                                                              01505000
      DO 2100 I=1,NEXPD                                                 01506000
      II=II+1                                                           01507000
      ITT=NFD-II+1                                                      01508000
      IT=MOD(IDGT,10)+1                                                 01509000
      IDGT=IDGT/10                                                      01510000
      IMAGE(ITT)=LTR(IT)                                                01511000
 2100 CONTINUE                                                          01512000
      IMAGE(ITT-1)=LTR(41)                                              01516000
      IF(IDIGIT .LT. 0) IMAGE(ITT-1)=LTR(42)                            01517000
      IMAGE(ITT-2)=LTR(15)                                              01521000
      NFD=NFD-NEXPD-2                                                   01522000
      IF(IFMTYP.NE.5) NOD=NFD-1                                         01524000
      IF(IFMTYP.NE.5 .AND. DVALUE.LT.0.D0) NOD=NOD-1                    01525000
      IFMTYP=5                                                          01526000
      ITER=2                                                            01527000
 3000 CONTINUE                                                          01528000
      DO 3010 I=1,NFD                                                   01529000
      IMAGE(I)=IBLANK                                                   01530000
 3010 CONTINUE                                                          01531000
      IMAGE(NFD)=LTR(1)                                                 01532000
      IGOTYP=IFMTYP-3                                                   01533000
      TVALUE=ADINT(AVALUE*(10.D0**NOD)+0.5D0)                           01534000
      NDIGIT=0                                                          01538000
      IF(TVALUE.GE.1.D0) NDIGIT=DLOG10(TVALUE)+1.D0                     01539000
      IF(DVALUE.LT.0.D0) NDIGIT=NDIGIT+1                                01540000
      CALL APRTLB(LEVOT,10000,20)                                       01541000
      IF(LEVOT.GE.10000) WRITE(IPRT,1005) DVALUE,AVALUE,TVALUE,         01542000
     * NOD,NFD,NDIGIT,IDIGIT                                            01543000
      II=0                                                              01547000
      NCBDP=0                                                           01549000
      NCBFD=0                                                           01551000
      NDGTA=0                                                           01553000
 3100 CONTINUE                                                          01554000
      II=II+1                                                           01555000
      IF(II.GT.NFD) GO TO 4000                                          01556000
      ITT=NFD-II+1                                                      01557000
      ITCHR=0                                                           01558000
      IF(TVALUE.LT.1.D0) GO TO 3200                                     01559000
      ITCHR=DMOD(TVALUE,10.D0)+1.D0                                     01560000
      TVALUE=TVALUE/10.D0                                               01561000
      IF(ITCHR.GE.1 .AND. ITCHR.LE.NOL) IMAGE(ITT)=LTR(ITCHR)           01562000
      NDGTA=NDGTA+1                                                     01563000
 3200 CONTINUE                                                          01564000
      IF(II-NOD) 3210,3300,3400                                         01565000
 3210 CONTINUE                                                          01566000
      IF(ITCHR.EQ.0) IMAGE(ITT)=LTR(1)                                  01567000
      GO TO 3100                                                        01568000
 3300 CONTINUE                                                          01572000
      IF(ITCHR.EQ.0) IMAGE(ITT)=LTR(1)                                  01573000
      II=II+1                                                           01574000
      ITT=NFD-II+1                                                      01575000
      IMAGE(ITT)=LTR(48)                                                01576000
      GO TO 3100                                                        01577000
 3400 CONTINUE                                                          01578000
      NCBDP=NCBDP+1                                                     01579000
      IF(ITCHR.EQ.0) NCBFD=NCBFD+1                                      01580000
      GO TO (3410,3410,3430,3440,3450,3460), IGOTYP                     01581000
 3410 CONTINUE                                                          01582000
      IF(NCBFD.EQ.0) GO TO 3100                                         01586000
      IF(DVALUE.GE.0.D0) GO TO 4000                                     01588000
      IMAGE(ITT)=LTR(42)                                                01589000
      NDGTA=NDGTA+1                                                     01590000
      GO TO 4000                                                        01591000
 3430 CONTINUE                                                          01592000
      CALL ACFTOB(NDGTA,DVALUE,TVALUE,NFD,II,NCBDP,NCBFD,IMAGE,LIMAGE)  01596000
      IF(NCBFD.EQ.0) GO TO 3100                                         01597000
      GO TO 4000                                                        01598000
 3440 CONTINUE                                                          01599000
      CALL ACFTOB(NDGTA,DVALUE,TVALUE,NFD,II,NCBDP,NCBFD,IMAGE,LIMAGE)  01603000
      IF(NCBFD.EQ.0) GO TO 3100                                         01604000
      ITT=NFD-II+1                                                      01605000
      IMAGE(ITT-1)=LTR(37)                                              01606000
      GO TO 4000                                                        01607000
 3450 CONTINUE                                                          01608000
      IF(NCBFD.EQ.0) GO TO 3100                                         01612000
      IMAGE(ITT)=LTR(1)                                                 01613000
      IF(NCBFD.NE.1 .OR. DVALUE.GE.0.D0) GO TO 3100                     01614000
      IMAGE(ITT)=LTR(42)                                                01615000
      NDGTA=NDGTA+1                                                     01616000
      GO TO 3100                                                        01617000
 3460 CONTINUE                                                          01618000
      CALL ACFTOB(NDGTA,DVALUE,TVALUE,NFD,II,NCBDP,NCBFD,IMAGE,LIMAGE)  01622000
      IF(NCBFD.LE.1) GO TO 3100                                         01623000
      IMAGE(ITT)=LTR(43)                                                01624000
      GO TO 3100                                                        01625000
 4000 CONTINUE                                                          01626000
 4005 FORMAT(1X,F20.6,5I4/1X,30A1)                                      01627000
      CALL APRTLB(LEVOT,10000,30)                                       01628000
      IF(LEVOT.GE.10000) WRITE(IPRT,4005) TVALUE,NDIGIT,NDGTA,II,ITT,IT,01629000
     *  (IMAGE(I),I=1,LIMAGE)                                           01630000
      IF(ITER.EQ.1 .AND. NDGTA.LT.NDIGIT) GO TO 2000                    01631000
      IF(II.LE.NFD) GO TO 9800                                          01632000
      IF((TVALUE.LT.1.D0).AND.(DVALUE.GE.0.D0)) GO TO 9800              01633000
      DO 4100 I=1,NFDALL                                                01634000
      IMAGE(I)=LTR(43)                                                  01635000
 4100 CONTINUE                                                          01636000
      GO TO 9800                                                        01637000
 6000 CONTINUE                                                          01643000
      CALL ACCTOI(DVALUE,ISCHR,20,NCHRS,0)                              01644000
      IBLK=NFD-NCHRS                                                    01645000
      GO TO (6100,6200,6300), IFMTYP                                    01646000
 6100 IT=0                                                              01647000
      GO TO 6500                                                        01648000
 6200 IT=IBLK/2                                                         01649000
      GO TO 6500                                                        01650000
 6300 IT=IBLK                                                           01651000
 6500 CONTINUE                                                          01652000
      ITT=NOL+1                                                         01653000
      DO 6600 I=1,NCHRS                                                 01654000
      IT=IT+1                                                           01655000
      IS=ISCHR(I)                                                       01656000
      IF(IS.EQ.1) IS=46                                                 01657000
      IF(IS.GE.1 .AND. IS.LE.ITT) IMAGE(IT)=LTR(IS-1)                   01658000
 6600 CONTINUE                                                          01659000
      GO TO 9800                                                        01660000
 8000 CONTINUE                                                          01661000
      IF(IFMT.GE.0) GO TO 9800                                          01662000
      IMAGE(NFD)=ISTAR                                                  01663000
      IF((NFD-1).GE.1) IMAGE(NFD-1)=ISTAR                               01664000
      IF((NFD-2).GE.1) IMAGE(NFD-2)=ISTAR                               01665000
 9800 CONTINUE                                                          01666000
      RETURN                                                            01668000
      END                                                               01669000
C*****ACFTOB                                                            01670000
      SUBROUTINE ACFTOB(NDGTA,DVALUE,TVALUE,NFD,II,NCBDP,NCBFD,IMAGE,   01671000
     *  LIMAGE)                                                         01672000
C* COPYRIGHT--  1981 BY SCA, INC.  ALL RIGHTS RESERVED.                 01674000
      INTEGER          IGORTN, II    , ITT   , LEVOT , LIMAGE, NCBDP ,  01734000
     *                 NCBFD , NDGTA , NFD                              01735000
      DOUBLE PRECISION DVALUE, TVALUE                                   01737000
C-CHR                                                                   01738000
      INTEGER          IMAGE                                            01739000
C/                                                                      01740000
C+CHR                                                                   01741000
C&    CHARACTER*4      IMAGE                                            01742000
C/                                                                      01743000
C-CHR                                                                   01744000
      DOUBLE PRECISION SNAME                                            01745000
C/                                                                      01746000
C+CHR                                                                   01747000
C&    CHARACTER*8      SNAME                                            01748000
C/                                                                      01749000
      DIMENSION IMAGE(LIMAGE)                                           01750000
C+CHR                                                                   01751000
C&    CHARACTER*4      LTR                                              01752000
C/                                                                      01753000
      COMMON / CMABCD / NOL   , LTR(88)                                 01754000
      DATA SNAME /6HACFTOB /                                            01755000
      LEVOT=0                                                           01760000
      IF(NCBFD.EQ.1) GO TO 1000                                         01763000
      IF(MOD(NCBDP,3).NE.0) GO TO 2000                                  01764000
      IF(TVALUE.LT.1.D0 .OR. II.GE.NFD) GO TO 2000                      01765000
      II=II+1                                                           01766000
      ITT=NFD-II+1                                                      01767000
      IMAGE(ITT)=LTR(46)                                                01768000
      GO TO 2000                                                        01769000
 1000 CONTINUE                                                          01770000
      II=II-1                                                           01774000
      IF(DVALUE.GE.0.D0 .OR. II.GE.NFD) GO TO 8000                      01775000
      II=II+1                                                           01776000
      ITT=NFD-II+1                                                      01777000
      IMAGE(ITT)=LTR(42)                                                01778000
      NDGTA=NDGTA+1                                                     01779000
 2000 CONTINUE                                                          01780000
 8000 CONTINUE                                                          01781000
      RETURN                                                            01783000
      END                                                               01784000
C*****ACFTOC                                                            01785000
      SUBROUTINE ACFTOC(LFSTC,DVALUE,IFMT,IMAGE,LIMAGE)                 01786000
C* COPYRIGHT--  1981 BY SCA, INC.  ALL RIGHTS RESERVED.                 01788000
      INTEGER          IFMT  , IGORTN, LEVOT , LFSTC , LIMAGE, LIMAGT   01851000
      DOUBLE PRECISION DVALUE                                           01853000
C-CHR                                                                   01854000
      INTEGER          IMAGE                                            01855000
C/                                                                      01856000
C+CHR                                                                   01857000
C&    CHARACTER*4      IMAGE                                            01858000
C/                                                                      01859000
C-CHR                                                                   01860000
      DOUBLE PRECISION SNAME                                            01861000
C/                                                                      01862000
C+CHR                                                                   01863000
C&    CHARACTER*8      SNAME                                            01864000
C/                                                                      01865000
      DIMENSION IMAGE(LIMAGE)                                           01866000
      DATA  SNAME /6HACFTOC/                                            01867000
      LEVOT=0                                                           01872000
      LIMAGT=LIMAGE-LFSTC+1                                             01875000
      CALL ACFTOA(DVALUE,IFMT,IMAGE(LFSTC),LIMAGT)                      01876000
 8000 CONTINUE                                                          01877000
      RETURN                                                            01879000
      END                                                               01880000
C*****ACFTOD                                                            01880002
      SUBROUTINE ACFTOD(DVALUE,IFMT,IMAGE,LIMAGE)                       01880004
C* COPYRIGHT--  1981 BY SCA, INC.  ALL RIGHTS RESERVED.                 01880008
      INTEGER          IBLK  , IDGT  , IDIGIT, IFMTYP, IFMT  , IGORTN,  01880146
     *                 IGOTYP, II    , ISCHR , IS    , ITCHR , ITER  ,  01880148
     *                 ITT   , IT    , I     , LEVOT , LIMAGE, NCBDP ,  01880150
     *                 NCBFD , NCHRS , NDGTA , NDIGIT, NEXPD , NFD   ,  01880152
     *                 NOD                                              01880154
      REAL             TV                                               01880158
      DOUBLE PRECISION ADINT , AVALUE, DVALUE, TVALUE                   01880162
C-CHR                                                                   01880164
      INTEGER          IMAGE , IBLANK, ISTAR                            01880166
C/                                                                      01880168
C+CHR                                                                   01880170
C&    CHARACTER*4      IMAGE , IBLANK, ISTAR                            01880172
C/                                                                      01880174
C-CHR                                                                   01880176
      DOUBLE PRECISION SNAME                                            01880178
C/                                                                      01880180
C+CHR                                                                   01880182
C&    CHARACTER*8      SNAME                                            01880184
C/                                                                      01880186
      DIMENSION IMAGE(LIMAGE),ISCHR(20)                                 01880188
      DOUBLE PRECISION  DMAXV , DMINV , DSML  , DEPS                    01880192
C-CHR                                                                   01880194
      DOUBLE PRECISION  DBLNK                                           01880196
C/                                                                      01880198
C+CHR                                                                   01880200
C&    CHARACTER*8       DBLNK                                           01880202
C/                                                                      01880204
      COMMON / CMDCST / DMAXV , DMINV , DSML  , DEPS  ,                 01880206
     *                  DBLNK                                           01880208
C+CHR                                                                   01880210
C&    CHARACTER*4       RBLNK                                           01880212
C/                                                                      01880214
      COMMON / CMRCST / RMAXV , RMINV , RSML  , REPS  ,                 01880216
     *                  RBLNK , RXEXP , DXEXP , RMISS ,                 01880218
     *                  RTRIG                                           01880220
C+CHR                                                                   01880222
C&    CHARACTER*4       LTR                                             01880224
C/                                                                      01880226
      COMMON / CMABCD / NOL   , LTR(88)                                 01880228
      COMMON / CMIOPA / IIPT  , IPRT  , IPCH  , IDSK  ,                 01880232
     *                  ICOPY , KRDWD , ITRMNL, LEVOTP,                 01880234
     *                  LENOTP, NOLPAG, IDECHO, IDMSOD,                 01880236
     *                  ISNTPT, IMSGPT, ICRCSS, NPGHRM,                 01880238
     *                  NOWPGH, NWRECF, NOLPP                           01880240
      DATA  IBLANK/4H      /                                            01880242
      DATA  ISTAR /1H*     /                                            01880244
      DATA  SNAME /6HACFTOD/                                            01880246
      LEVOT=0                                                           01880256
      ITER=1                                                            01880262
      IFMTT=IABS(IFMT)                                                  01880264
      IFMTYP=MOD(IFMTT,10)                                              01880266
      NOD=MOD(IFMTT,1000)/10                                            01880268
      NFD=IFMTT/1000                                                    01880270
      NFDALL=NFD                                                        01880272
      TVALUE=RMISS                                                      01880280
      DO 800 I=1,LIMAGE                                                 01880282
      IMAGE(I)=IBLANK                                                   01880284
  800 CONTINUE                                                          01880286
      IF(DABS(DVALUE-TVALUE).LE.0.1D0 .OR.                              01880288
     *   DABS(DVALUE-2.D0*TVALUE).LE.0.1D0) GO TO 8000                  01880290
      IF(DABS(DVALUE).GE.DMAXV) GO TO 8000                              01880292
      IF(IFMTYP.LE.3) GO TO 6000                                        01880294
      AVALUE=DABS(DVALUE)                                               01880306
      IF(IFMTYP.NE.4) GO TO 900                                         01880308
      IF((AVALUE.LE.(10.D0**(-NOD-0))) .OR.                             01880316
     *   (AVALUE.GE.(10.D0**(-NOD)))) GO TO 900                         01880318
      IF(NFD.LE.6) GO TO 900                                            01880320
      IFMTYP=5                                                          01880322
      NOD=NFD-6                                                         01880324
      IF(DVALUE.LT.0.D0) NOD=NOD-1                                      01880326
  900 CONTINUE                                                          01880328
 1005 FORMAT(1X,3F20.6/1X,10I4)                                         01880330
      IF(IFMTYP.NE.5) GO TO 3000                                        01880332
 2000 CONTINUE                                                          01880334
      IDIGIT=0                                                          01880344
      IF(AVALUE.LE.DSML) GO TO 2200                                     01880346
      TVALUE=DLOG10(AVALUE)                                             01880348
      IDIGIT=DLOG10(AVALUE)+1.D0+DSIGN(0.0001D0,TVALUE)                 01880352
      IF(AVALUE.LT.0.1) IDIGIT=IDIGIT-1                                 01880358
      AVALUE=AVALUE/(10.D0**IDIGIT)                                     01880360
 2200 TV=IABS(IDIGIT)                                                   01880362
      NEXPD=0                                                           01880364
      IF(TV.GT.0.1) NEXPD=ALOG10(TV)+REPS                               01880366
      NEXPD=MAX0(2,NEXPD)                                               01880368
      IDGT=IABS(IDIGIT)                                                 01880376
      II=0                                                              01880378
      DO 2100 I=1,NEXPD                                                 01880380
      II=II+1                                                           01880382
      ITT=NFD-II+1                                                      01880384
      IT=MOD(IDGT,10)+1                                                 01880386
      IDGT=IDGT/10                                                      01880388
      IMAGE(ITT)=LTR(IT)                                                01880390
 2100 CONTINUE                                                          01880392
      IMAGE(ITT-1)=LTR(41)                                              01880400
      IF(IDIGIT .LT. 0) IMAGE(ITT-1)=LTR(42)                            01880402
      IMAGE(ITT-2)=LTR(15)                                              01880410
      NFD=NFD-NEXPD-2                                                   01880412
      IF(IFMTYP.NE.5) NOD=NFD-1                                         01880416
      IF(IFMTYP.NE.5 .AND. DVALUE.LT.0.D0) NOD=NOD-1                    01880418
      IFMTYP=5                                                          01880420
      ITER=2                                                            01880422
 3000 CONTINUE                                                          01880424
      DO 3010 I=1,NFD                                                   01880426
      IMAGE(I)=IBLANK                                                   01880428
 3010 CONTINUE                                                          01880430
      IMAGE(NFD)=LTR(1)                                                 01880432
      IGOTYP=IFMTYP-3                                                   01880434
      TVALUE=ADINT(AVALUE*(10.D0**NOD)+0.5D0)                           01880436
      NDIGIT=0                                                          01880444
      IF(TVALUE.GE.1.D0) NDIGIT=DLOG10(TVALUE)+1.D0                     01880446
      IF(DVALUE.LT.0.D0) NDIGIT=NDIGIT+1                                01880448
      CALL APRTLB(LEVOT,10000,20)                                       01880450
      IF(LEVOT.GE.10000) WRITE(IPRT,1005) DVALUE,AVALUE,TVALUE,         01880452
     * NOD,NFD,NDIGIT,IDIGIT                                            01880454
      II=0                                                              01880462
      NCBDP=0                                                           01880466
      NCBFD=0                                                           01880470
      NDGTA=0                                                           01880474
 3100 CONTINUE                                                          01880476
      II=II+1                                                           01880478
      IF(II.GT.NFD) GO TO 4000                                          01880480
      ITT=NFD-II+1                                                      01880482
      ITCHR=0                                                           01880484
      IF(TVALUE.LT.1.D0) GO TO 3200                                     01880486
      ITCHR=DMOD(TVALUE,10.D0)+1.D0                                     01880488
      TVALUE=TVALUE/10.D0                                               01880490
      IF(ITCHR.GE.1 .AND. ITCHR.LE.NOL) IMAGE(ITT)=LTR(ITCHR)           01880492
      NDGTA=NDGTA+1                                                     01880494
 3200 CONTINUE                                                          01880496
      IF(II-NOD) 3210,3300,3400                                         01880498
 3210 CONTINUE                                                          01880500
      IF(ITCHR.EQ.0) IMAGE(ITT)=LTR(1)                                  01880502
      GO TO 3100                                                        01880504
 3300 CONTINUE                                                          01880512
      IF(ITCHR.EQ.0) IMAGE(ITT)=LTR(1)                                  01880514
      II=II+1                                                           01880516
      ITT=NFD-II+1                                                      01880518
      IMAGE(ITT)=LTR(48)                                                01880520
      GO TO 3100                                                        01880522
 3400 CONTINUE                                                          01880524
      NCBDP=NCBDP+1                                                     01880526
      IF(ITCHR.EQ.0) NCBFD=NCBFD+1                                      01880528
      GO TO (3410,3410,3430,3440,3450,3460), IGOTYP                     01880530
 3410 CONTINUE                                                          01880532
      IF(NCBFD.EQ.0) GO TO 3100                                         01880540
      IF(DVALUE.GE.0.D0) GO TO 4000                                     01880544
      IMAGE(ITT)=LTR(42)                                                01880546
      NDGTA=NDGTA+1                                                     01880548
      GO TO 4000                                                        01880550
 3430 CONTINUE                                                          01880552
      CALL ACFTOB(NDGTA,DVALUE,TVALUE,NFD,II,NCBDP,NCBFD,IMAGE,LIMAGE)  01880560
      IF(NCBFD.EQ.0) GO TO 3100                                         01880562
      GO TO 4000                                                        01880564
 3440 CONTINUE                                                          01880566
      CALL ACFTOB(NDGTA,DVALUE,TVALUE,NFD,II,NCBDP,NCBFD,IMAGE,LIMAGE)  01880574
      IF(NCBFD.EQ.0) GO TO 3100                                         01880576
      ITT=NFD-II+1                                                      01880578
      IMAGE(ITT-1)=LTR(37)                                              01880580
      GO TO 4000                                                        01880582
 3450 CONTINUE                                                          01880584
      IF(NCBFD.EQ.0) GO TO 3100                                         01880592
      IMAGE(ITT)=LTR(1)                                                 01880594
      IF(NCBFD.NE.1 .OR. DVALUE.GE.0.D0) GO TO 3100                     01880596
      IMAGE(ITT)=LTR(42)                                                01880598
      NDGTA=NDGTA+1                                                     01880600
      GO TO 3100                                                        01880602
 3460 CONTINUE                                                          01880604
      CALL ACFTOB(NDGTA,DVALUE,TVALUE,NFD,II,NCBDP,NCBFD,IMAGE,LIMAGE)  01880612
      IF(NCBFD.LE.1) GO TO 3100                                         01880614
      IMAGE(ITT)=LTR(43)                                                01880616
      GO TO 3100                                                        01880618
 4000 CONTINUE                                                          01880620
 4005 FORMAT(1X,F20.6,5I4/1X,30A1)                                      01880622
      CALL APRTLB(LEVOT,10000,30)                                       01880624
      IF(LEVOT.GE.10000) WRITE(IPRT,4005) TVALUE,NDIGIT,NDGTA,II,ITT,IT,01880626
     *  (IMAGE(I),I=1,LIMAGE)                                           01880628
      IF(ITER.EQ.1 .AND. NDGTA.LT.NDIGIT) GO TO 2000                    01880630
      IF(II.LE.NFD) GO TO 9800                                          01880632
      IF((TVALUE.LT.1.D0).AND.(DVALUE.GE.0.D0)) GO TO 9800              01880634
      DO 4100 I=1,NFDALL                                                01880636
      IMAGE(I)=LTR(43)                                                  01880638
 4100 CONTINUE                                                          01880640
      GO TO 9800                                                        01880642
 6000 CONTINUE                                                          01880654
      CALL ACCTOI(DVALUE,ISCHR,20,NCHRS,0)                              01880656
      IBLK=NFD-NCHRS                                                    01880658
      GO TO (6100,6200,6300), IFMTYP                                    01880660
 6100 IT=0                                                              01880662
      GO TO 6500                                                        01880664
 6200 IT=IBLK/2                                                         01880666
      GO TO 6500                                                        01880668
 6300 IT=IBLK                                                           01880670
 6500 CONTINUE                                                          01880672
      ITT=NOL+1                                                         01880674
      DO 6600 I=1,NCHRS                                                 01880676
      IT=IT+1                                                           01880678
      IS=ISCHR(I)                                                       01880680
      IF(IS.EQ.1) IS=46                                                 01880682
      IF(IS.GE.1 .AND. IS.LE.ITT) IMAGE(IT)=LTR(IS-1)                   01880684
 6600 CONTINUE                                                          01880686
      GO TO 9800                                                        01880688
 8000 CONTINUE                                                          01880690
      IF(IFMT.GE.0) GO TO 9800                                          01880692
      IMAGE(NFD)=ISTAR                                                  01880694
      IF((NFD-1).GE.1) IMAGE(NFD-1)=ISTAR                               01880696
      IF((NFD-2).GE.1) IMAGE(NFD-2)=ISTAR                               01880698
 9800 CONTINUE                                                          01880700
      RETURN                                                            01880704
      END                                                               01880706
C*****ACFTOE                                                            01880709
      SUBROUTINE ACFTOE(LFSTC,DVALUE,IFMT,IMAGE,LIMAGE)                 01880712
C* COPYRIGHT--  1981 BY SCA, INC.  ALL RIGHTS RESERVED.                 01880718
      INTEGER          IFMT  , IGORTN, LEVOT , LFSTC , LIMAGE, LIMAGT   01880907
      DOUBLE PRECISION DVALUE                                           01880913
C-CHR                                                                   01880916
      INTEGER          IMAGE                                            01880919
C/                                                                      01880922
C+CHR                                                                   01880925
C&    CHARACTER*4      IMAGE                                            01880928
C/                                                                      01880931
C-CHR                                                                   01880934
      DOUBLE PRECISION SNAME                                            01880937
C/                                                                      01880940
C+CHR                                                                   01880943
C&    CHARACTER*8      SNAME                                            01880946
C/                                                                      01880949
      DIMENSION IMAGE(LIMAGE)                                           01880952
      DATA  SNAME /6HACFTOE/                                            01880955
      LEVOT=0                                                           01880970
      LIMAGT=LIMAGE-LFSTC+1                                             01880979
      CALL ACFTOD(DVALUE,IFMT,IMAGE(LFSTC),LIMAGT)                      01880982
 8000 CONTINUE                                                          01880985
      RETURN                                                            01880991
      END                                                               01880994
C*****ACCTOI                                                            00775000
      SUBROUTINE ACCTOI(DARG,ICARD,LENCRD,NCHRS,MNUS01)                 00776000
C* COPYRIGHT--  1981 BY SCA, INC.  ALL RIGHTS RESERVED.                 00778000
      INTEGER          ICARD , IGORTN, IT    , I     , LENCRD, LEVOT ,  00828000
     *                 MNUS01, MNUST , NCHRS                            00829000
      DOUBLE PRECISION DARGT , DARG                                     00831000
C-CHR                                                                   00832000
      DOUBLE PRECISION SNAME                                            00833000
C/                                                                      00834000
C+CHR                                                                   00835000
C&    CHARACTER*8      SNAME                                            00836000
C/                                                                      00837000
      DIMENSION ICARD(LENCRD)                                           00838000
      DOUBLE PRECISION  DMAXV , DMINV , DSML  , DEPS                    00839000
C-CHR                                                                   00840000
      DOUBLE PRECISION  DBLNK                                           00841000
C/                                                                      00842000
C+CHR                                                                   00843000
C&    CHARACTER*8       DBLNK                                           00844000
C/                                                                      00845000
      COMMON / CMDCST / DMAXV , DMINV , DSML  , DEPS  ,                 00846000
     *                  DBLNK                                           00847000
C+CHR                                                                   00848000
C&    CHARACTER*4       LTR                                             00849000
C/                                                                      00850000
      COMMON / CMABCD / NOL   , LTR(88)                                 00851000
      DATA  SNAME /6HACCTOI/                                            00852000
      LEVOT=0                                                           00857000
      MNUST=MNUS01                                                      00859000
      IF(MNUS01.EQ.2) MNUST=0                                           00860000
      DARGT=DABS(DARG)                                                  00861000
      NCHRS=DLOG10(DARGT)/2.D0+1.D0+DEPS                                00862000
      DO 100 I=1,NCHRS                                                  00864000
      IT=DARGT/(100.D0**(NCHRS-I))+DEPS-MNUST                           00865000
      ICARD(I)=IT                                                       00866000
      DARGT=DARGT-DFLOAT(IT+MNUST)*(100.D0**(NCHRS-I))                  00867000
  100 CONTINUE                                                          00868000
      IF(MNUS01.NE.2) GO TO 8000                                        00869000
      DO 200 I=1,NCHRS                                                  00873000
      IT=ICARD(I)                                                       00874000
      ICARD(I)=LTR(IT)                                                  00875000
  200 CONTINUE                                                          00876000
 8000 CONTINUE                                                          00877000
      RETURN                                                            00879000
      END                                                               00880000
C*****DARCOS
      FUNCTION DARCOS(X)
c     DOUBLE PRECISION DARCOS
      DOUBLE PRECISION X
      DARCOS=DACOS(X)
      RETURN
      END
